# amis

A Low-Code frontend UI Framework. You can quickly develop various management pages by only using JSON configuration. Frontend skill is not required.

Currently used in Baidu's internal infrastructure, created more than 40000 pages.

To build your own backend system with amis, you can refer to this: https://github.com/fex-team/amis-admin

## Quick start

```
# Install project npm dependencies.
npm i

# Start compiling and output the code to the webroot directory of the service you just opened.
npm run dev

# Open the fis3 service, please visit http://127.0.0.1:8888/examples/pages/simple.
npm start
```

## Testing

```bash
#Installation dependency
npm i

#Executing test cases
npm test

# View test case coverage
npm run coverage
```

## Working with documents

For a better reading experience, it is recommended to read https://baidu.github.io/amis/ directly in gh-pages.

- [Quick Start](/docs/getting_started.md)
- [Basic Usage](/docs/basic.md)
- [Advanced Usage](/docs/advanced.md)
- [Render Manual](/docs/renderers.md)
- [How to customize](/docs/sdk.md)
- [custom component](/docs/dev.md)
- [Auxiliary Style](/docs/style.md)

## How to contribute

Please write in typescript, all reasonable changes, new public renderers, use cases, or document submissions will be received.

## Maintainer

- [2betop](https://github.com/2betop)
- [RickCole21](https://github.com/RickCole21)
- [catchonme](https://github.com/catchonme)

## Discussion

Welcome to ISSUE for discussion.
