/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.27.0(730c98dfd4e771a851edf1bc944ea5c5018ee8cb)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var z=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/range","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],G=function(I){for(var t=[],E=0,P=I.length;E<P;E++)t[E]=z[I[E]];return t},he=this,de=typeof global=="object"?global:{},X;(function(I){I.global=he;var t=function(){function E(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(E.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),E.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=E._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof I.global.importScripts=="function")},E._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},E}();I.Environment=t})(X||(X={}));var X;(function(I){var t=function(){function A(l,h,a){this.type=l,this.detail=h,this.timestamp=a}return A}();I.LoaderEvent=t;var E=function(){function A(l){this._events=[new t(1,"",l)]}return A.prototype.record=function(l,h){this._events.push(new t(l,h,I.Utilities.getHighPerformanceTimestamp()))},A.prototype.getEvents=function(){return this._events},A}();I.LoaderEventRecorder=E;var P=function(){function A(){}return A.prototype.record=function(l,h){},A.prototype.getEvents=function(){return[]},A.INSTANCE=new A,A}();I.NullLoaderEventRecorder=P})(X||(X={}));var X;(function(I){var t=function(){function E(){}return E.fileUriToFilePath=function(P,A){if(A=decodeURI(A).replace(/%23/g,"#"),P){if(/^file:\/\/\//.test(A))return A.substr(8);if(/^file:\/\//.test(A))return A.substr(5)}else if(/^file:\/\//.test(A))return A.substr(7);return A},E.startsWith=function(P,A){return P.length>=A.length&&P.substr(0,A.length)===A},E.endsWith=function(P,A){return P.length>=A.length&&P.substr(P.length-A.length)===A},E.containsQueryString=function(P){return/^[^\#]*\?/gi.test(P)},E.isAbsolutePath=function(P){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(P)},E.forEachProperty=function(P,A){if(P){var l=void 0;for(l in P)P.hasOwnProperty(l)&&A(l,P[l])}},E.isEmpty=function(P){var A=!0;return E.forEachProperty(P,function(){A=!1}),A},E.recursiveClone=function(P){if(!P||typeof P!="object"||P instanceof RegExp||!Array.isArray(P)&&Object.getPrototypeOf(P)!==Object.prototype)return P;var A=Array.isArray(P)?[]:{};return E.forEachProperty(P,function(l,h){h&&typeof h=="object"?A[l]=E.recursiveClone(h):A[l]=h}),A},E.generateAnonymousModule=function(){return"===anonymous"+E.NEXT_ANONYMOUS_ID+++"==="},E.isAnonymousModule=function(P){return E.startsWith(P,"===anonymous")},E.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=I.global.performance&&typeof I.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?I.global.performance.now():Date.now()},E.NEXT_ANONYMOUS_ID=1,E.PERFORMANCE_NOW_PROBED=!1,E.HAS_PERFORMANCE_NOW=!1,E}();I.Utilities=t})(X||(X={}));var X;(function(I){function t(A){if(A instanceof Error)return A;var l=new Error(A.message||String(A)||"Unknown Error");return A.stack&&(l.stack=A.stack),l}I.ensureError=t;var E=function(){function A(){}return A.validateConfigurationOptions=function(l){function h(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory method of "'+o.moduleId+'" has thrown an exception'),console.error(o);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError=="undefined"&&(l.catchError=!1),typeof l.recordStats=="undefined"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=h),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(I.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags=="undefined"&&(l.preferScriptTags=!1),Array.isArray(l.nodeModules)||(l.nodeModules=[]),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){var a=t(new Error("INVALID cached data configuration, 'path' MUST be set"));a.phase="configuration",l.onError(a),l.nodeCachedData=void 0}return l},A.mergeConfigurationOptions=function(l,h){l===void 0&&(l=null),h===void 0&&(h=null);var a=I.Utilities.recursiveClone(h||{});return I.Utilities.forEachProperty(l,function(o,f){o==="ignoreDuplicateModules"&&typeof a.ignoreDuplicateModules!="undefined"?a.ignoreDuplicateModules=a.ignoreDuplicateModules.concat(f):o==="paths"&&typeof a.paths!="undefined"?I.Utilities.forEachProperty(f,function(S,c){return a.paths[S]=c}):o==="config"&&typeof a.config!="undefined"?I.Utilities.forEachProperty(f,function(S,c){return a.config[S]=c}):a[o]=I.Utilities.recursiveClone(f)}),A.validateConfigurationOptions(a)},A}();I.ConfigurationOptionsUtil=E;var P=function(){function A(l,h){if(this._env=l,this.options=E.mergeConfigurationOptions(h),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var a=this.options.nodeRequire.main.filename,o=Math.max(a.lastIndexOf("/"),a.lastIndexOf("\\"));this.options.baseUrl=a.substring(0,o+1)}if(this.options.nodeMain&&this._env.isNode){var a=this.options.nodeMain,o=Math.max(a.lastIndexOf("/"),a.lastIndexOf("\\"));this.options.baseUrl=a.substring(0,o+1)}}}return A.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0},A.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var l=0,h=this.options.nodeModules;l<h.length;l++){var a=h[l];this.nodeModulesMap[a]=!0}},A.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],I.Utilities.forEachProperty(this.options.paths,function(h,a){Array.isArray(a)?l.sortedPathsRules.push({from:h,to:a}):l.sortedPathsRules.push({from:h,to:[a]})}),this.sortedPathsRules.sort(function(h,a){return a.from.length-h.from.length})},A.prototype.cloneAndMerge=function(l){return new A(this._env,E.mergeConfigurationOptions(l,this.options))},A.prototype.getOptionsLiteral=function(){return this.options},A.prototype._applyPaths=function(l){for(var h,a=0,o=this.sortedPathsRules.length;a<o;a++)if(h=this.sortedPathsRules[a],I.Utilities.startsWith(l,h.from)){for(var f=[],S=0,c=h.to.length;S<c;S++)f.push(h.to[S]+l.substr(h.from.length));return f}return[l]},A.prototype._addUrlArgsToUrl=function(l){return I.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},A.prototype._addUrlArgsIfNecessaryToUrl=function(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l},A.prototype._addUrlArgsIfNecessaryToUrls=function(l){if(this.options.urlArgs)for(var h=0,a=l.length;h<a;h++)l[h]=this._addUrlArgsToUrl(l[h]);return l},A.prototype.moduleIdToPaths=function(l){var h=this.nodeModulesMap[l]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l);if(h)return this.isBuild()?["empty:"]:["node|"+l];var a=l,o;if(!I.Utilities.endsWith(a,".js")&&!I.Utilities.isAbsolutePath(a)){o=this._applyPaths(a);for(var f=0,S=o.length;f<S;f++)this.isBuild()&&o[f]==="empty:"||(I.Utilities.isAbsolutePath(o[f])||(o[f]=this.options.baseUrl+o[f]),!I.Utilities.endsWith(o[f],".js")&&!I.Utilities.containsQueryString(o[f])&&(o[f]=o[f]+".js"))}else!I.Utilities.endsWith(a,".js")&&!I.Utilities.containsQueryString(a)&&(a=a+".js"),o=[a];return this._addUrlArgsIfNecessaryToUrls(o)},A.prototype.requireToUrl=function(l){var h=l;return I.Utilities.isAbsolutePath(h)||(h=this._applyPaths(h)[0],I.Utilities.isAbsolutePath(h)||(h=this.options.baseUrl+h)),this._addUrlArgsIfNecessaryToUrl(h)},A.prototype.isBuild=function(){return this.options.isBuild},A.prototype.isDuplicateMessageIgnoredFor=function(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)},A.prototype.getConfigForModule=function(l){if(this.options.config)return this.options.config[l]},A.prototype.shouldCatchError=function(){return this.options.catchError},A.prototype.shouldRecordStats=function(){return this.options.recordStats},A.prototype.onError=function(l){this.options.onError(l)},A}();I.Configuration=P})(X||(X={}));var X;(function(I){var t=function(){function a(o){this._env=o,this._scriptLoader=null,this._callbackMap={}}return a.prototype.load=function(o,f,S,c){var g=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new P;else if(this._env.isElectronRenderer){var m=o.getConfig().getOptionsLiteral().preferScriptTags;m?this._scriptLoader=new E:this._scriptLoader=new A(this._env)}else this._env.isNode?this._scriptLoader=new A(this._env):this._scriptLoader=new E;var v={callback:S,errorback:c};if(this._callbackMap.hasOwnProperty(f)){this._callbackMap[f].push(v);return}this._callbackMap[f]=[v],this._scriptLoader.load(o,f,function(){return g.triggerCallback(f)},function(i){return g.triggerErrorback(f,i)})},a.prototype.triggerCallback=function(o){var f=this._callbackMap[o];delete this._callbackMap[o];for(var S=0;S<f.length;S++)f[S].callback()},a.prototype.triggerErrorback=function(o,f){var S=this._callbackMap[o];delete this._callbackMap[o];for(var c=0;c<S.length;c++)S[c].errorback(f)},a}(),E=function(){function a(){}return a.prototype.attachListeners=function(o,f,S){var c=function(){o.removeEventListener("load",g),o.removeEventListener("error",m)},g=function(v){c(),f()},m=function(v){c(),S(v)};o.addEventListener("load",g),o.addEventListener("error",m)},a.prototype.load=function(o,f,S,c){if(/^node\|/.test(f)){var g=o.getConfig().getOptionsLiteral(),m=l(o.getRecorder(),g.nodeRequire||I.global.nodeRequire),v=f.split("|"),i=null;try{i=m(v[1])}catch(n){c(n);return}o.enqueueDefineAnonymousModule([],function(){return i}),S()}else{var u=document.createElement("script");u.setAttribute("async","async"),u.setAttribute("type","text/javascript"),this.attachListeners(u,S,c);var _=o.getConfig().getOptionsLiteral().trustedTypesPolicy;_&&(f=_.createScriptURL(f)),u.setAttribute("src",f);var L=o.getConfig().getOptionsLiteral().cspNonce;L&&u.setAttribute("nonce",L),document.getElementsByTagName("head")[0].appendChild(u)}},a}(),P=function(){function a(){}return a.prototype.load=function(o,f,S,c){var g=o.getConfig().getOptionsLiteral().trustedTypesPolicy,m=/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,self.origin.length)!==self.origin;if(!m){fetch(f).then(function(v){if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(function(v){v=v+`
//# sourceURL=`+f;var i=g?self.eval(g.createScript("",v)):new Function(v);i.call(self),S()}).then(void 0,c);return}try{g&&(f=g.createScriptURL(f)),importScripts(f),S()}catch(v){c(v)}},a}(),A=function(){function a(o){this._env=o,this._didInitialize=!1,this._didPatchNodeRequire=!1}return a.prototype._init=function(o){this._didInitialize||(this._didInitialize=!0,this._fs=o("fs"),this._vm=o("vm"),this._path=o("path"),this._crypto=o("crypto"))},a.prototype._initNodeRequire=function(o,f){var S=f.getConfig().getOptionsLiteral().nodeCachedData;if(!S||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var c=this,g=o("module");function m(v){var i=v.constructor,u=function(L){try{return v.require(L)}finally{}};return u.resolve=function(L,n){return i._resolveFilename(L,v,!1,n)},u.resolve.paths=function(L){return i._resolveLookupPaths(L,v)},u.main=process.mainModule,u.extensions=i._extensions,u.cache=i._cache,u}g.prototype._compile=function(v,i){var u=g.wrap(v.replace(/^#!.*/,"")),_=f.getRecorder(),L=c._getCachedDataPath(S,i),n={filename:i},r;try{var s=c._fs.readFileSync(L);r=s.slice(0,16),n.cachedData=s.slice(16),_.record(60,L)}catch(M){_.record(61,L)}var d=new c._vm.Script(u,n),C=d.runInThisContext(n),b=c._path.dirname(i),N=m(this),w=[this.exports,N,this,i,b,process,de,Buffer],y=C.apply(this.exports,w);return c._handleCachedData(d,u,L,!n.cachedData,f),c._verifyCachedData(d,u,L,r,f),y}},a.prototype.load=function(o,f,S,c){var g=this,m=o.getConfig().getOptionsLiteral(),v=l(o.getRecorder(),m.nodeRequire||I.global.nodeRequire),i=m.nodeInstrumenter||function(C){return C};this._init(v),this._initNodeRequire(v,o);var u=o.getRecorder();if(/^node\|/.test(f)){var _=f.split("|"),L=null;try{L=v(_[1])}catch(C){c(C);return}o.enqueueDefineAnonymousModule([],function(){return L}),S()}else{f=I.Utilities.fileUriToFilePath(this._env.isWindows,f);var n=this._path.normalize(f),r=this._getElectronRendererScriptPathOrUri(n),s=Boolean(m.nodeCachedData),d=s?this._getCachedDataPath(m.nodeCachedData,f):void 0;this._readSourceAndCachedData(n,d,u,function(C,b,N,w){if(C){c(C);return}var y;b.charCodeAt(0)===a._BOM?y=a._PREFIX+b.substring(1)+a._SUFFIX:y=a._PREFIX+b+a._SUFFIX,y=i(y,n);var M={filename:r,cachedData:N},U=g._createAndEvalScript(o,y,M,S,c);g._handleCachedData(U,y,d,s&&!N,o),g._verifyCachedData(U,y,d,w,o)})}},a.prototype._createAndEvalScript=function(o,f,S,c,g){var m=o.getRecorder();m.record(31,S.filename);var v=new this._vm.Script(f,S),i=v.runInThisContext(S),u=o.getGlobalAMDDefineFunc(),_=!1,L=function(){return _=!0,u.apply(null,arguments)};return L.amd=u.amd,i.call(I.global,o.getGlobalAMDRequireFunc(),L,S.filename,this._path.dirname(S.filename)),m.record(32,S.filename),_?c():g(new Error("Didn't receive define call in "+S.filename+"!")),v},a.prototype._getElectronRendererScriptPathOrUri=function(o){if(!this._env.isElectronRenderer)return o;var f=o.match(/^([a-z])\:(.*)/i);return f?"file:///"+(f[1].toUpperCase()+":"+f[2]).replace(/\\/g,"/"):"file://"+o},a.prototype._getCachedDataPath=function(o,f){var S=this._crypto.createHash("md5").update(f,"utf8").update(o.seed,"utf8").update(process.arch,"").digest("hex"),c=this._path.basename(f).replace(/\.js$/,"");return this._path.join(o.path,c+"-"+S+".code")},a.prototype._handleCachedData=function(o,f,S,c,g){var m=this;o.cachedDataRejected?this._fs.unlink(S,function(v){g.getRecorder().record(62,S),m._createAndWriteCachedData(o,f,S,g),v&&g.getConfig().onError(v)}):c&&this._createAndWriteCachedData(o,f,S,g)},a.prototype._createAndWriteCachedData=function(o,f,S,c){var g=this,m=Math.ceil(c.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),v=-1,i=0,u=void 0,_=function(){setTimeout(function(){u||(u=g._crypto.createHash("md5").update(f,"utf8").digest());var L=o.createCachedData();if(!(L.length===0||L.length===v||i>=5)){if(L.length<v){_();return}v=L.length,g._fs.writeFile(S,Buffer.concat([u,L]),function(n){n&&c.getConfig().onError(n),c.getRecorder().record(63,S),_()})}},m*Math.pow(4,i++))};_()},a.prototype._readSourceAndCachedData=function(o,f,S,c){if(!f)this._fs.readFile(o,{encoding:"utf8"},c);else{var g=void 0,m=void 0,v=void 0,i=2,u=function(_){_?c(_):--i==0&&c(void 0,g,m,v)};this._fs.readFile(o,{encoding:"utf8"},function(_,L){g=L,u(_)}),this._fs.readFile(f,function(_,L){!_&&L&&L.length>0?(v=L.slice(0,16),m=L.slice(16),S.record(60,f)):S.record(61,f),u()})}},a.prototype._verifyCachedData=function(o,f,S,c,g){var m=this;!c||o.cachedDataRejected||setTimeout(function(){var v=m._crypto.createHash("md5").update(f,"utf8").digest();c.equals(v)||(g.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+S+"' now, but a RESTART IS REQUIRED")),m._fs.unlink(S,function(i){i&&g.getConfig().onError(i)}))},Math.ceil(5e3*(1+Math.random())))},a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`,a}();function l(a,o){if(o.__$__isRecorded)return o;var f=function(c){a.record(33,c);try{return o(c)}finally{a.record(34,c)}};return f.__$__isRecorded=!0,f}I.ensureRecordedNodeRequire=l;function h(a){return new t(a)}I.createScriptLoader=h})(X||(X={}));var X;(function(I){var t=function(){function a(o){var f=o.lastIndexOf("/");f!==-1?this.fromModulePath=o.substr(0,f+1):this.fromModulePath=""}return a._normalizeModuleId=function(o){var f=o,S;for(S=/\/\.\//;S.test(f);)f=f.replace(S,"/");for(f=f.replace(/^\.\//g,""),S=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;S.test(f);)f=f.replace(S,"/");return f=f.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),f},a.prototype.resolveModule=function(o){var f=o;return I.Utilities.isAbsolutePath(f)||(I.Utilities.startsWith(f,"./")||I.Utilities.startsWith(f,"../"))&&(f=a._normalizeModuleId(this.fromModulePath+f)),f},a.ROOT=new a(""),a}();I.ModuleIdResolver=t;var E=function(){function a(o,f,S,c,g,m){this.id=o,this.strId=f,this.dependencies=S,this._callback=c,this._errorback=g,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return a._safeInvokeFunction=function(o,f){try{return{returnedValue:o.apply(I.global,f),producedError:null}}catch(S){return{returnedValue:null,producedError:S}}},a._invokeFactory=function(o,f,S,c){return o.isBuild()&&!I.Utilities.isAnonymousModule(f)?{returnedValue:null,producedError:null}:o.shouldCatchError()?this._safeInvokeFunction(S,c):{returnedValue:S.apply(I.global,c),producedError:null}},a.prototype.complete=function(o,f,S){this._isComplete=!0;var c=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var g=a._invokeFactory(f,this.strId,this._callback,S);c=g.producedError,o.record(22,this.strId),!c&&typeof g.returnedValue!="undefined"&&(!this.exportsPassedIn||I.Utilities.isEmpty(this.exports))&&(this.exports=g.returnedValue)}else this.exports=this._callback;if(c){var m=I.ensureError(c);m.phase="factory",m.moduleId=this.strId,this.error=m,f.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},a.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},a.prototype.isComplete=function(){return this._isComplete},a}();I.Module=E;var P=function(){function a(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return a.prototype.getMaxModuleId=function(){return this._nextId},a.prototype.getModuleId=function(o){var f=this._strModuleIdToIntModuleId.get(o);return typeof f=="undefined"&&(f=this._nextId++,this._strModuleIdToIntModuleId.set(o,f),this._intModuleIdToStrModuleId[f]=o),f},a.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},a}(),A=function(){function a(o){this.id=o}return a.EXPORTS=new a(0),a.MODULE=new a(1),a.REQUIRE=new a(2),a}();I.RegularDependency=A;var l=function(){function a(o,f,S){this.id=o,this.pluginId=f,this.pluginParam=S}return a}();I.PluginDependency=l;var h=function(){function a(o,f,S,c,g){g===void 0&&(g=0),this._env=o,this._scriptLoader=f,this._loaderAvailableTimestamp=g,this._defineFunc=S,this._requireFunc=c,this._moduleIdProvider=new P,this._config=new I.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return a.prototype.reset=function(){return new a(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},a.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},a.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},a._findRelevantLocationInStack=function(o,f){for(var S=function(r){return r.replace(/\\/g,"/")},c=S(o),g=f.split(/\n/),m=0;m<g.length;m++){var v=g[m].match(/(.*):(\d+):(\d+)\)?$/);if(v){var i=v[1],u=v[2],_=v[3],L=Math.max(i.lastIndexOf(" ")+1,i.lastIndexOf("(")+1);if(i=i.substr(L),i=S(i),i===c){var n={line:parseInt(u,10),col:parseInt(_,10)};return n.line===1&&(n.col-="(function (require, define, __filename, __dirname) { ".length),n}}}throw new Error("Could not correlate define call site for needle "+o)},a.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],f=0,S=0,c=this._modules2.length;S<c;S++){var g=this._modules2[S];if(!!g){var m=this._buildInfoPath[g.id]||null,v=this._buildInfoDefineStack[g.id]||null,i=this._buildInfoDependencies[g.id];o[f++]={id:g.strId,path:m,defineLocation:m&&v?a._findRelevantLocationInStack(m,v):null,dependencies:i,shim:null,exports:g.exports}}}return o},a.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new I.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=I.NullLoaderEventRecorder.INSTANCE),this._recorder},a.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},a.prototype.enqueueDefineAnonymousModule=function(o,f){if(this._currentAnnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var S=null;this._config.isBuild()&&(S=new Error("StackLocation").stack||null),this._currentAnnonymousDefineCall={stack:S,dependencies:o,callback:f}},a.prototype.defineModule=function(o,f,S,c,g,m){var v=this;m===void 0&&(m=new t(o));var i=this._moduleIdProvider.getModuleId(o);if(this._modules2[i]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var u=new E(i,o,this._normalizeDependencies(f,m),S,c,m);this._modules2[i]=u,this._config.isBuild()&&(this._buildInfoDefineStack[i]=g,this._buildInfoDependencies[i]=(u.dependencies||[]).map(function(_){return v._moduleIdProvider.getStrModuleId(_.id)})),this._resolve(u)},a.prototype._normalizeDependency=function(o,f){if(o==="exports")return A.EXPORTS;if(o==="module")return A.MODULE;if(o==="require")return A.REQUIRE;var S=o.indexOf("!");if(S>=0){var c=f.resolveModule(o.substr(0,S)),g=f.resolveModule(o.substr(S+1)),m=this._moduleIdProvider.getModuleId(c+"!"+g),v=this._moduleIdProvider.getModuleId(c);return new l(m,v,g)}return new A(this._moduleIdProvider.getModuleId(f.resolveModule(o)))},a.prototype._normalizeDependencies=function(o,f){for(var S=[],c=0,g=0,m=o.length;g<m;g++)S[c++]=this._normalizeDependency(o[g],f);return S},a.prototype._relativeRequire=function(o,f,S,c){if(typeof f=="string")return this.synchronousRequire(f,o);this.defineModule(I.Utilities.generateAnonymousModule(),f,S,c,null,o)},a.prototype.synchronousRequire=function(o,f){f===void 0&&(f=new t(o));var S=this._normalizeDependency(o,f),c=this._modules2[S.id];if(!c)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!c.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(c.error)throw c.error;return c.exports},a.prototype.configure=function(o,f){var S=this._config.shouldRecordStats();f?this._config=new I.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!S&&(this._recorder=null)},a.prototype.getConfig=function(){return this._config},a.prototype._onLoad=function(o){if(this._currentAnnonymousDefineCall!==null){var f=this._currentAnnonymousDefineCall;this._currentAnnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),f.dependencies,f.callback,null,f.stack)}},a.prototype._createLoadError=function(o,f){var S=this,c=this._moduleIdProvider.getStrModuleId(o),g=(this._inverseDependencies2[o]||[]).map(function(v){return S._moduleIdProvider.getStrModuleId(v)}),m=I.ensureError(f);return m.phase="loading",m.moduleId=c,m.neededBy=g,m},a.prototype._onLoadError=function(o,f){var S=this._createLoadError(o,f);this._modules2[o]||(this._modules2[o]=new E(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},function(){},null));for(var c=[],g=0,m=this._moduleIdProvider.getMaxModuleId();g<m;g++)c[g]=!1;var v=!1,i=[];for(i.push(o),c[o]=!0;i.length>0;){var u=i.shift(),_=this._modules2[u];_&&(v=_.onDependencyError(S)||v);var L=this._inverseDependencies2[u];if(L)for(var g=0,m=L.length;g<m;g++){var n=L[g];c[n]||(i.push(n),c[n]=!0)}}v||this._config.onError(S)},a.prototype._hasDependencyPath=function(o,f){var S=this._modules2[o];if(!S)return!1;for(var c=[],g=0,m=this._moduleIdProvider.getMaxModuleId();g<m;g++)c[g]=!1;var v=[];for(v.push(S),c[o]=!0;v.length>0;){var i=v.shift(),u=i.dependencies;if(u)for(var g=0,m=u.length;g<m;g++){var _=u[g];if(_.id===f)return!0;var L=this._modules2[_.id];L&&!c[_.id]&&(c[_.id]=!0,v.push(L))}}return!1},a.prototype._findCyclePath=function(o,f,S){if(o===f||S===50)return[o];var c=this._modules2[o];if(!c)return null;var g=c.dependencies;if(g)for(var m=0,v=g.length;m<v;m++){var i=this._findCyclePath(g[m].id,f,S+1);if(i!==null)return i.push(o),i}return null},a.prototype._createRequire=function(o){var f=this,S=function(c,g,m){return f._relativeRequire(o,c,g,m)};return S.toUrl=function(c){return f._config.requireToUrl(o.resolveModule(c))},S.getStats=function(){return f.getLoaderEvents()},S.hasDependencyCycle=function(){return f._hasDependencyCycle},S.config=function(c,g){g===void 0&&(g=!1),f.configure(c,g)},S.__$__nodeRequire=I.global.nodeRequire,S},a.prototype._loadModule=function(o){var f=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var S=this._moduleIdProvider.getStrModuleId(o),c=this._config.moduleIdToPaths(S),g=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(S.indexOf("/")===-1||g.test(S))&&c.push("node|"+S);var m=-1,v=function(i){if(m++,m>=c.length)f._onLoadError(o,i);else{var u=c[m],_=f.getRecorder();if(f._config.isBuild()&&u==="empty:"){f._buildInfoPath[o]=u,f.defineModule(f._moduleIdProvider.getStrModuleId(o),[],null,null,null),f._onLoad(o);return}_.record(10,u),f._scriptLoader.load(f,u,function(){f._config.isBuild()&&(f._buildInfoPath[o]=u),_.record(11,u),f._onLoad(o)},function(L){_.record(12,u),v(L)})}};v(null)}},a.prototype._loadPluginDependency=function(o,f){var S=this;if(!(this._modules2[f.id]||this._knownModules2[f.id])){this._knownModules2[f.id]=!0;var c=function(g){S.defineModule(S._moduleIdProvider.getStrModuleId(f.id),[],g,null,null)};c.error=function(g){S._config.onError(S._createLoadError(f.id,g))},o.load(f.pluginParam,this._createRequire(t.ROOT),c,this._config.getOptionsLiteral())}},a.prototype._resolve=function(o){var f=this,S=o.dependencies;if(S)for(var c=0,g=S.length;c<g;c++){var m=S[c];if(m===A.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(m===A.MODULE){o.unresolvedDependenciesCount--;continue}if(m===A.REQUIRE){o.unresolvedDependenciesCount--;continue}var v=this._modules2[m.id];if(v&&v.isComplete()){if(v.error){o.onDependencyError(v.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var i=this._findCyclePath(m.id,o.id,0)||[];i.reverse(),i.push(m.id),console.warn(i.map(function(L){return f._moduleIdProvider.getStrModuleId(L)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(o.id),m instanceof l){var u=this._modules2[m.pluginId];if(u&&u.isComplete()){this._loadPluginDependency(u.exports,m);continue}var _=this._inversePluginDependencies2.get(m.pluginId);_||(_=[],this._inversePluginDependencies2.set(m.pluginId,_)),_.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},a.prototype._onModuleComplete=function(o){var f=this,S=this.getRecorder();if(!o.isComplete()){var c=o.dependencies,g=[];if(c)for(var m=0,v=c.length;m<v;m++){var i=c[m];if(i===A.EXPORTS){g[m]=o.exports;continue}if(i===A.MODULE){g[m]={id:o.strId,config:function(){return f._config.getConfigForModule(o.strId)}};continue}if(i===A.REQUIRE){g[m]=this._createRequire(o.moduleIdResolver);continue}var u=this._modules2[i.id];if(u){g[m]=u.exports;continue}g[m]=null}o.complete(S,this._config,g);var _=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,_)for(var m=0,v=_.length;m<v;m++){var L=_[m],n=this._modules2[L];n.unresolvedDependenciesCount--,n.unresolvedDependenciesCount===0&&this._onModuleComplete(n)}var r=this._inversePluginDependencies2.get(o.id);if(r){this._inversePluginDependencies2.delete(o.id);for(var m=0,v=r.length;m<v;m++)this._loadPluginDependency(o.exports,r[m])}}},a}();I.ModuleManager=h})(X||(X={}));var Y,X;(function(I){var t=new I.Environment,E=null,P=function(a,o,f){typeof a!="string"&&(f=o,o=a,a=null),(typeof o!="object"||!Array.isArray(o))&&(f=o,o=null),o||(o=["require","exports","module"]),a?E.defineModule(a,o,f,null,null):E.enqueueDefineAnonymousModule(o,f)};P.amd={jQuery:!0};var A=function(a,o){o===void 0&&(o=!1),E.configure(a,o)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){A(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(I.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=A,l.getConfig=function(){return E.getConfig().getOptionsLiteral()},l.reset=function(){E=E.reset()},l.getBuildInfo=function(){return E.getBuildInfo()},l.getStats=function(){return E.getLoaderEvents()},l.define=function(){return P.apply(null,arguments)};function h(){if(typeof I.global.require!="undefined"||typeof require!="undefined"){var a=I.global.require||require;if(typeof a=="function"&&typeof a.resolve=="function"){var o=I.ensureRecordedNodeRequire(E.getRecorder(),a);I.global.nodeRequire=o,l.nodeRequire=o,l.__$__nodeRequire=o}}t.isNode&&!t.isElectronRenderer?(module.exports=l,require=l):(t.isElectronRenderer||(I.global.define=P),I.global.require=l)}I.init=h,(typeof I.global.define!="function"||!I.global.define.amd)&&(E=new I.ModuleManager(t,I.createScriptLoader(t),P,l,I.Utilities.getHighPerformanceTimestamp()),typeof I.global.require!="undefined"&&typeof I.global.require!="function"&&l.config(I.global.require),Y=function(){return P.apply(null,arguments)},Y.amd=P.amd,typeof doNotInitLoader=="undefined"&&h())})(X||(X={})),Y(z[14],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class E{constructor(A,l,h,a){this.originalStart=A,this.originalLength=l,this.modifiedStart=h,this.modifiedLength=a}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=E}),Y(z[4],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.illegalState=t.illegalArgument=t.canceled=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.errorHandler=t.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(g){setTimeout(()=>{throw g.stack?new Error(g.message+`

`+g.stack):g},0)}}emit(g){this.listeners.forEach(m=>{m(g)})}onUnexpectedError(g){this.unexpectedErrorHandler(g),this.emit(g)}onUnexpectedExternalError(g){this.unexpectedErrorHandler(g)}}t.ErrorHandler=E,t.errorHandler=new E;function P(c){a(c)||t.errorHandler.onUnexpectedError(c)}t.onUnexpectedError=P;function A(c){a(c)||t.errorHandler.onUnexpectedExternalError(c)}t.onUnexpectedExternalError=A;function l(c){if(c instanceof Error){let{name:g,message:m}=c;const v=c.stacktrace||c.stack;return{$isError:!0,name:g,message:m,stack:v}}return c}t.transformErrorForSerialization=l;const h="Canceled";function a(c){return c instanceof Error&&c.name===h&&c.message===h}t.isPromiseCanceledError=a;function o(){const c=new Error(h);return c.name=c.message,c}t.canceled=o;function f(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}t.illegalArgument=f;function S(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}t.illegalState=S}),Y(z[15],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function E(P){const A=this;let l=!1,h;return function(){return l||(l=!0,h=P.apply(A,arguments)),h}}t.once=E}),Y(z[16],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(P){function A(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}P.is=A;const l=Object.freeze([]);function h(){return l}P.empty=h;function*a(s){yield s}P.single=a;function o(s){return s||l}P.from=o;function f(s){return!s||s[Symbol.iterator]().next().done===!0}P.isEmpty=f;function S(s){return s[Symbol.iterator]().next().value}P.first=S;function c(s,d){for(const C of s)if(d(C))return!0;return!1}P.some=c;function g(s,d){for(const C of s)if(d(C))return C}P.find=g;function*m(s,d){for(const C of s)d(C)&&(yield C)}P.filter=m;function*v(s,d){let C=0;for(const b of s)yield d(b,C++)}P.map=v;function*i(...s){for(const d of s)for(const C of d)yield C}P.concat=i;function*u(s){for(const d of s)for(const C of d)yield C}P.concatNested=u;function _(s,d,C){let b=C;for(const N of s)b=d(b,N);return b}P.reduce=_;function*L(s,d,C=s.length){for(d<0&&(d+=s.length),C<0?C+=s.length:C>s.length&&(C=s.length);d<C;d++)yield s[d]}P.slice=L;function n(s,d=Number.POSITIVE_INFINITY){const C=[];if(d===0)return[C,s];const b=s[Symbol.iterator]();for(let N=0;N<d;N++){const w=b.next();if(w.done)return[C,P.empty()];C.push(w.value)}return[C,{[Symbol.iterator](){return b}}]}P.consume=n;function r(s,d,C=(b,N)=>b===N){const b=s[Symbol.iterator](),N=d[Symbol.iterator]();for(;;){const w=b.next(),y=N.next();if(w.done!==y.done)return!1;if(w.done)return!0;if(!C(w.value,y.value))return!1}}P.equals=r})(E=t.Iterable||(t.Iterable={}))}),Y(z[17],G([0,1,4]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyCodeUtils=void 0;class P{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,_){this._keyCodeToStr[u]=_,this._strToKeyCode[_.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const A=new P,l=new P,h=new P;(function(){function i(u,_,L=_,n=L){A.define(u,_),l.define(u,L),h.define(u,n)}i(0,"unknown"),i(1,"Backspace"),i(2,"Tab"),i(3,"Enter"),i(4,"Shift"),i(5,"Ctrl"),i(6,"Alt"),i(7,"PauseBreak"),i(8,"CapsLock"),i(9,"Escape"),i(10,"Space"),i(11,"PageUp"),i(12,"PageDown"),i(13,"End"),i(14,"Home"),i(15,"LeftArrow","Left"),i(16,"UpArrow","Up"),i(17,"RightArrow","Right"),i(18,"DownArrow","Down"),i(19,"Insert"),i(20,"Delete"),i(21,"0"),i(22,"1"),i(23,"2"),i(24,"3"),i(25,"4"),i(26,"5"),i(27,"6"),i(28,"7"),i(29,"8"),i(30,"9"),i(31,"A"),i(32,"B"),i(33,"C"),i(34,"D"),i(35,"E"),i(36,"F"),i(37,"G"),i(38,"H"),i(39,"I"),i(40,"J"),i(41,"K"),i(42,"L"),i(43,"M"),i(44,"N"),i(45,"O"),i(46,"P"),i(47,"Q"),i(48,"R"),i(49,"S"),i(50,"T"),i(51,"U"),i(52,"V"),i(53,"W"),i(54,"X"),i(55,"Y"),i(56,"Z"),i(57,"Meta"),i(58,"ContextMenu"),i(59,"F1"),i(60,"F2"),i(61,"F3"),i(62,"F4"),i(63,"F5"),i(64,"F6"),i(65,"F7"),i(66,"F8"),i(67,"F9"),i(68,"F10"),i(69,"F11"),i(70,"F12"),i(71,"F13"),i(72,"F14"),i(73,"F15"),i(74,"F16"),i(75,"F17"),i(76,"F18"),i(77,"F19"),i(78,"NumLock"),i(79,"ScrollLock"),i(80,";",";","OEM_1"),i(81,"=","=","OEM_PLUS"),i(82,",",",","OEM_COMMA"),i(83,"-","-","OEM_MINUS"),i(84,".",".","OEM_PERIOD"),i(85,"/","/","OEM_2"),i(86,"`","`","OEM_3"),i(110,"ABNT_C1"),i(111,"ABNT_C2"),i(87,"[","[","OEM_4"),i(88,"\\","\\","OEM_5"),i(89,"]","]","OEM_6"),i(90,"'","'","OEM_7"),i(91,"OEM_8"),i(92,"OEM_102"),i(93,"NumPad0"),i(94,"NumPad1"),i(95,"NumPad2"),i(96,"NumPad3"),i(97,"NumPad4"),i(98,"NumPad5"),i(99,"NumPad6"),i(100,"NumPad7"),i(101,"NumPad8"),i(102,"NumPad9"),i(103,"NumPad_Multiply"),i(104,"NumPad_Add"),i(105,"NumPad_Separator"),i(106,"NumPad_Subtract"),i(107,"NumPad_Decimal"),i(108,"NumPad_Divide")})();var a;(function(i){function u(s){return A.keyCodeToStr(s)}i.toString=u;function _(s){return A.strToKeyCode(s)}i.fromString=_;function L(s){return l.keyCodeToStr(s)}i.toUserSettingsUS=L;function n(s){return h.keyCodeToStr(s)}i.toUserSettingsGeneral=n;function r(s){return l.strToKeyCode(s)||h.strToKeyCode(s)}i.fromUserSettings=r})(a=t.KeyCodeUtils||(t.KeyCodeUtils={}));function o(i,u){const _=(u&65535)<<16>>>0;return(i|_)>>>0}t.KeyChord=o;function f(i,u){if(i===0)return null;const _=(i&65535)>>>0,L=(i&4294901760)>>>16;return L!==0?new g([S(_,u),S(L,u)]):new g([S(_,u)])}t.createKeybinding=f;function S(i,u){const _=!!(i&2048),L=!!(i&256),n=u===2?L:_,r=!!(i&1024),s=!!(i&512),d=u===2?_:L,C=i&255;return new c(n,r,s,d,C)}t.createSimpleKeybinding=S;class c{constructor(u,_,L,n,r){this.ctrlKey=u,this.shiftKey=_,this.altKey=L,this.metaKey=n,this.keyCode=r}equals(u){return this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=c;class g{constructor(u){if(u.length===0)throw(0,E.illegalArgument)("parts");this.parts=u}}t.ChordKeybinding=g;class m{constructor(u,_,L,n,r,s){this.ctrlKey=u,this.shiftKey=_,this.altKey=L,this.metaKey=n,this.keyLabel=r,this.keyAriaLabel=s}}t.ResolvedKeybindingPart=m;class v{}t.ResolvedKeybinding=v}),Y(z[7],G([0,1,15,16]),function(I,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const A=!1;let l=null;function h(s){l=s}if(t.setDisposableTracker=h,A){const s="__is_disposable_tracked__";h(new class{trackDisposable(d){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[s]||console.log(C)},3e3)}setParent(d,C){if(d&&d!==L.None)try{d[s]=!0}catch(b){}}markAsDisposed(d){if(d&&d!==L.None)try{d[s]=!0}catch(C){}}markAsSingleton(d){}})}function a(s){return l==null||l.trackDisposable(s),s}function o(s){l==null||l.markAsDisposed(s)}function f(s,d){l==null||l.setParent(s,d)}function S(s,d){if(!!l)for(const C of s)l.setParent(C,d)}function c(s){return l==null||l.markAsSingleton(s),s}t.markAsSingleton=c;class g extends Error{constructor(d){super(`Encountered errors while disposing of store. Errors: [${d.join(", ")}]`);this.errors=d}}t.MultiDisposeError=g;function m(s){return typeof s.dispose=="function"&&s.dispose.length===0}t.isDisposable=m;function v(s){if(P.Iterable.is(s)){let d=[];for(const C of s)if(C)try{C.dispose()}catch(b){d.push(b)}if(d.length===1)throw d[0];if(d.length>1)throw new g(d);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}t.dispose=v;function i(...s){const d=u(()=>v(s));return S(s,d),d}t.combinedDisposable=i;function u(s){const d=a({dispose:(0,E.once)(()=>{o(d),s()})});return d}t.toDisposable=u;class _{constructor(){this._toDispose=new Set,this._isDisposed=!1,a(this)}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return f(d,this),this._isDisposed?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(d),d}}t.DisposableStore=_,_.DISABLE_DISPOSED_WARNING=!1;class L{constructor(){this._store=new _,a(this),f(this._store,this)}dispose(){o(this),this._store.dispose()}_register(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(d)}}t.Disposable=L,L.None=Object.freeze({dispose(){}});class n{constructor(){this._isDisposed=!1,a(this)}get value(){return this._isDisposed?void 0:this._value}set value(d){var C;this._isDisposed||d===this._value||((C=this._value)===null||C===void 0||C.dispose(),d&&f(d,this),this._value=d)}clear(){this.value=void 0}dispose(){var d;this._isDisposed=!0,o(this),(d=this._value)===null||d===void 0||d.dispose(),this._value=void 0}clearAndLeak(){const d=this._value;return this._value=void 0,d&&f(d,null),d}}t.MutableDisposable=n;class r{constructor(d){this.object=d}dispose(){}}t.ImmortalReference=r}),Y(z[18],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class E{constructor(l){this.element=l,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class P{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let l=this._first;for(;l!==E.Undefined;){const h=l.next;l.prev=E.Undefined,l.next=E.Undefined,l=h}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(l){return this._insert(l,!1)}push(l){return this._insert(l,!0)}_insert(l,h){const a=new E(l);if(this._first===E.Undefined)this._first=a,this._last=a;else if(h){const f=this._last;this._last=a,a.prev=f,f.next=a}else{const f=this._first;this._first=a,a.next=f,f.prev=a}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(a))}}shift(){if(this._first!==E.Undefined){const l=this._first.element;return this._remove(this._first),l}}pop(){if(this._last!==E.Undefined){const l=this._last.element;return this._remove(this._last),l}}_remove(l){if(l.prev!==E.Undefined&&l.next!==E.Undefined){const h=l.prev;h.next=l.next,l.next.prev=h}else l.prev===E.Undefined&&l.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):l.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):l.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let l=this._first;for(;l!==E.Undefined;)yield l.element,l=l.next}}t.LinkedList=P}),Y(z[2],G([0,1]),function(I,t){"use strict";var E;Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.setImmediate=t.userAgent=t.isIOS=t.isWeb=t.isNative=t.isLinux=t.isMacintosh=t.isWindows=t.isPreferringBrowserCodeLoad=t.browserCodeLoadingCacheStrategy=t.isElectronSandboxed=t.globals=void 0;const P="en";let A=!1,l=!1,h=!1,a=!1,o=!1,f=!1,S=!1,c,g=P,m,v;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let i;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?i=t.globals.vscode.process:typeof process!="undefined"&&(i=process);const u=typeof((E=i==null?void 0:i.versions)===null||E===void 0?void 0:E.electron)=="string"&&i.type==="renderer";if(t.isElectronSandboxed=u&&(i==null?void 0:i.sandboxed),t.browserCodeLoadingCacheStrategy=(()=>{if(t.isElectronSandboxed)return"bypassHeatCheck";const s=i==null?void 0:i.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),t.isPreferringBrowserCodeLoad=typeof t.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!u)v=navigator.userAgent,A=v.indexOf("Windows")>=0,l=v.indexOf("Macintosh")>=0,S=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,h=v.indexOf("Linux")>=0,f=!0,c=navigator.language,g=c;else if(typeof i=="object"){A=i.platform==="win32",l=i.platform==="darwin",h=i.platform==="linux",a=h&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,c=P,g=P;const s=i.env.VSCODE_NLS_CONFIG;if(s)try{const d=JSON.parse(s),C=d.availableLanguages["*"];c=d.locale,g=C||P,m=d._translationsConfigFile}catch(d){}o=!0}else console.error("Unable to resolve platform.");let _=0;l?_=1:A?_=3:h&&(_=2),t.isWindows=A,t.isMacintosh=l,t.isLinux=h,t.isNative=o,t.isWeb=f,t.isIOS=S,t.userAgent=v,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let C=[];t.globals.addEventListener("message",N=>{if(N.data&&N.data.vscodeSetImmediateId)for(let w=0,y=C.length;w<y;w++){const M=C[w];if(M.id===N.data.vscodeSetImmediateId){C.splice(w,1),M.callback();return}}});let b=0;return N=>{const w=++b;C.push({id:w,callback:N}),t.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof(i==null?void 0:i.nextTick)=="function")return i.nextTick.bind(i);const d=Promise.resolve();return C=>d.then(C)}(),t.OS=l||S?2:A?1:3;let L=!0,n=!1;function r(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,L=new Uint16Array(s.buffer)[0]===(2<<8)+1}return L}t.isLittleEndian=r}),Y(z[19],G([0,1,2]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.platform=t.env=t.cwd=void 0;let P;if(typeof E.globals.vscode!="undefined"&&typeof E.globals.vscode.process!="undefined"){const A=E.globals.vscode.process;P={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(l){return(0,E.setImmediate)(l)}}}else typeof process!="undefined"?P={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:P={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(A){return(0,E.setImmediate)(A)},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.platform=P.platform}),Y(z[20],G([0,1,19]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sep=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.normalize=t.posix=t.win32=void 0;const P=65,A=97,l=90,h=122,a=46,o=47,f=92,S=58,c=63;class g extends Error{constructor(r,s,d){let C;typeof s=="string"&&s.indexOf("not ")===0?(C="must not be",s=s.replace(/^not /,"")):C="must be";const b=r.indexOf(".")!==-1?"property":"argument";let N=`The "${r}" ${b} ${C} of type ${s}`;N+=`. Received type ${typeof d}`,super(N),this.code="ERR_INVALID_ARG_TYPE"}}function m(n,r){if(typeof n!="string")throw new g(r,"string",n)}function v(n){return n===o||n===f}function i(n){return n===o}function u(n){return n>=P&&n<=l||n>=A&&n<=h}function _(n,r,s,d){let C="",b=0,N=-1,w=0,y=0;for(let M=0;M<=n.length;++M){if(M<n.length)y=n.charCodeAt(M);else{if(d(y))break;y=o}if(d(y)){if(!(N===M-1||w===1))if(w===2){if(C.length<2||b!==2||C.charCodeAt(C.length-1)!==a||C.charCodeAt(C.length-2)!==a){if(C.length>2){const U=C.lastIndexOf(s);U===-1?(C="",b=0):(C=C.slice(0,U),b=C.length-1-C.lastIndexOf(s)),N=M,w=0;continue}else if(C.length!==0){C="",b=0,N=M,w=0;continue}}r&&(C+=C.length>0?`${s}..`:"..",b=2)}else C.length>0?C+=`${s}${n.slice(N+1,M)}`:C=n.slice(N+1,M),b=M-N-1;N=M,w=0}else y===a&&w!==-1?++w:w=-1}return C}function L(n,r){if(r===null||typeof r!="object")throw new g("pathObject","Object",r);const s=r.dir||r.root,d=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${d}`:`${s}${n}${d}`:d}t.win32={resolve(...n){let r="",s="",d=!1;for(let C=n.length-1;C>=-1;C--){let b;if(C>=0){if(b=n[C],m(b,"path"),b.length===0)continue}else r.length===0?b=E.cwd():(b=E.env[`=${r}`]||E.cwd(),(b===void 0||b.slice(0,2).toLowerCase()!==r.toLowerCase()&&b.charCodeAt(2)===f)&&(b=`${r}\\`));const N=b.length;let w=0,y="",M=!1;const U=b.charCodeAt(0);if(N===1)v(U)&&(w=1,M=!0);else if(v(U))if(M=!0,v(b.charCodeAt(1))){let D=2,q=D;for(;D<N&&!v(b.charCodeAt(D));)D++;if(D<N&&D!==q){const V=b.slice(q,D);for(q=D;D<N&&v(b.charCodeAt(D));)D++;if(D<N&&D!==q){for(q=D;D<N&&!v(b.charCodeAt(D));)D++;(D===N||D!==q)&&(y=`\\\\${V}\\${b.slice(q,D)}`,w=D)}}}else w=1;else u(U)&&b.charCodeAt(1)===S&&(y=b.slice(0,2),w=2,N>2&&v(b.charCodeAt(2))&&(M=!0,w=3));if(y.length>0)if(r.length>0){if(y.toLowerCase()!==r.toLowerCase())continue}else r=y;if(d){if(r.length>0)break}else if(s=`${b.slice(w)}\\${s}`,d=M,M&&r.length>0)break}return s=_(s,!d,"\\",v),d?`${r}\\${s}`:`${r}${s}`||"."},normalize(n){m(n,"path");const r=n.length;if(r===0)return".";let s=0,d,C=!1;const b=n.charCodeAt(0);if(r===1)return i(b)?"\\":n;if(v(b))if(C=!0,v(n.charCodeAt(1))){let w=2,y=w;for(;w<r&&!v(n.charCodeAt(w));)w++;if(w<r&&w!==y){const M=n.slice(y,w);for(y=w;w<r&&v(n.charCodeAt(w));)w++;if(w<r&&w!==y){for(y=w;w<r&&!v(n.charCodeAt(w));)w++;if(w===r)return`\\\\${M}\\${n.slice(y)}\\`;w!==y&&(d=`\\\\${M}\\${n.slice(y,w)}`,s=w)}}}else s=1;else u(b)&&n.charCodeAt(1)===S&&(d=n.slice(0,2),s=2,r>2&&v(n.charCodeAt(2))&&(C=!0,s=3));let N=s<r?_(n.slice(s),!C,"\\",v):"";return N.length===0&&!C&&(N="."),N.length>0&&v(n.charCodeAt(r-1))&&(N+="\\"),d===void 0?C?`\\${N}`:N:C?`${d}\\${N}`:`${d}${N}`},isAbsolute(n){m(n,"path");const r=n.length;if(r===0)return!1;const s=n.charCodeAt(0);return v(s)||r>2&&u(s)&&n.charCodeAt(1)===S&&v(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let r,s;for(let b=0;b<n.length;++b){const N=n[b];m(N,"path"),N.length>0&&(r===void 0?r=s=N:r+=`\\${N}`)}if(r===void 0)return".";let d=!0,C=0;if(typeof s=="string"&&v(s.charCodeAt(0))){++C;const b=s.length;b>1&&v(s.charCodeAt(1))&&(++C,b>2&&(v(s.charCodeAt(2))?++C:d=!1))}if(d){for(;C<r.length&&v(r.charCodeAt(C));)C++;C>=2&&(r=`\\${r.slice(C)}`)}return t.win32.normalize(r)},relative(n,r){if(m(n,"from"),m(r,"to"),n===r)return"";const s=t.win32.resolve(n),d=t.win32.resolve(r);if(s===d||(n=s.toLowerCase(),r=d.toLowerCase(),n===r))return"";let C=0;for(;C<n.length&&n.charCodeAt(C)===f;)C++;let b=n.length;for(;b-1>C&&n.charCodeAt(b-1)===f;)b--;const N=b-C;let w=0;for(;w<r.length&&r.charCodeAt(w)===f;)w++;let y=r.length;for(;y-1>w&&r.charCodeAt(y-1)===f;)y--;const M=y-w,U=N<M?N:M;let D=-1,q=0;for(;q<U;q++){const k=n.charCodeAt(C+q);if(k!==r.charCodeAt(w+q))break;k===f&&(D=q)}if(q!==U){if(D===-1)return d}else{if(M>U){if(r.charCodeAt(w+q)===f)return d.slice(w+q+1);if(q===2)return d.slice(w+q)}N>U&&(n.charCodeAt(C+q)===f?D=q:q===2&&(D=3)),D===-1&&(D=0)}let V="";for(q=C+D+1;q<=b;++q)(q===b||n.charCodeAt(q)===f)&&(V+=V.length===0?"..":"\\..");return w+=D,V.length>0?`${V}${d.slice(w,y)}`:(d.charCodeAt(w)===f&&++w,d.slice(w,y))},toNamespacedPath(n){if(typeof n!="string")return n;if(n.length===0)return"";const r=t.win32.resolve(n);if(r.length<=2)return n;if(r.charCodeAt(0)===f){if(r.charCodeAt(1)===f){const s=r.charCodeAt(2);if(s!==c&&s!==a)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(u(r.charCodeAt(0))&&r.charCodeAt(1)===S&&r.charCodeAt(2)===f)return`\\\\?\\${r}`;return n},dirname(n){m(n,"path");const r=n.length;if(r===0)return".";let s=-1,d=0;const C=n.charCodeAt(0);if(r===1)return v(C)?n:".";if(v(C)){if(s=d=1,v(n.charCodeAt(1))){let w=2,y=w;for(;w<r&&!v(n.charCodeAt(w));)w++;if(w<r&&w!==y){for(y=w;w<r&&v(n.charCodeAt(w));)w++;if(w<r&&w!==y){for(y=w;w<r&&!v(n.charCodeAt(w));)w++;if(w===r)return n;w!==y&&(s=d=w+1)}}}}else u(C)&&n.charCodeAt(1)===S&&(s=r>2&&v(n.charCodeAt(2))?3:2,d=s);let b=-1,N=!0;for(let w=r-1;w>=d;--w)if(v(n.charCodeAt(w))){if(!N){b=w;break}}else N=!1;if(b===-1){if(s===-1)return".";b=s}return n.slice(0,b)},basename(n,r){r!==void 0&&m(r,"ext"),m(n,"path");let s=0,d=-1,C=!0,b;if(n.length>=2&&u(n.charCodeAt(0))&&n.charCodeAt(1)===S&&(s=2),r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let N=r.length-1,w=-1;for(b=n.length-1;b>=s;--b){const y=n.charCodeAt(b);if(v(y)){if(!C){s=b+1;break}}else w===-1&&(C=!1,w=b+1),N>=0&&(y===r.charCodeAt(N)?--N==-1&&(d=b):(N=-1,d=w))}return s===d?d=w:d===-1&&(d=n.length),n.slice(s,d)}for(b=n.length-1;b>=s;--b)if(v(n.charCodeAt(b))){if(!C){s=b+1;break}}else d===-1&&(C=!1,d=b+1);return d===-1?"":n.slice(s,d)},extname(n){m(n,"path");let r=0,s=-1,d=0,C=-1,b=!0,N=0;n.length>=2&&n.charCodeAt(1)===S&&u(n.charCodeAt(0))&&(r=d=2);for(let w=n.length-1;w>=r;--w){const y=n.charCodeAt(w);if(v(y)){if(!b){d=w+1;break}continue}C===-1&&(b=!1,C=w+1),y===a?s===-1?s=w:N!==1&&(N=1):s!==-1&&(N=-1)}return s===-1||C===-1||N===0||N===1&&s===C-1&&s===d+1?"":n.slice(s,C)},format:L.bind(null,"\\"),parse(n){m(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const s=n.length;let d=0,C=n.charCodeAt(0);if(s===1)return v(C)?(r.root=r.dir=n,r):(r.base=r.name=n,r);if(v(C)){if(d=1,v(n.charCodeAt(1))){let D=2,q=D;for(;D<s&&!v(n.charCodeAt(D));)D++;if(D<s&&D!==q){for(q=D;D<s&&v(n.charCodeAt(D));)D++;if(D<s&&D!==q){for(q=D;D<s&&!v(n.charCodeAt(D));)D++;D===s?d=D:D!==q&&(d=D+1)}}}}else if(u(C)&&n.charCodeAt(1)===S){if(s<=2)return r.root=r.dir=n,r;if(d=2,v(n.charCodeAt(2))){if(s===3)return r.root=r.dir=n,r;d=3}}d>0&&(r.root=n.slice(0,d));let b=-1,N=d,w=-1,y=!0,M=n.length-1,U=0;for(;M>=d;--M){if(C=n.charCodeAt(M),v(C)){if(!y){N=M+1;break}continue}w===-1&&(y=!1,w=M+1),C===a?b===-1?b=M:U!==1&&(U=1):b!==-1&&(U=-1)}return w!==-1&&(b===-1||U===0||U===1&&b===w-1&&b===N+1?r.base=r.name=n.slice(N,w):(r.name=n.slice(N,b),r.base=n.slice(N,w),r.ext=n.slice(b,w))),N>0&&N!==d?r.dir=n.slice(0,N-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...n){let r="",s=!1;for(let d=n.length-1;d>=-1&&!s;d--){const C=d>=0?n[d]:E.cwd();m(C,"path"),C.length!==0&&(r=`${C}/${r}`,s=C.charCodeAt(0)===o)}return r=_(r,!s,"/",i),s?`/${r}`:r.length>0?r:"."},normalize(n){if(m(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===o,s=n.charCodeAt(n.length-1)===o;return n=_(n,!r,"/",i),n.length===0?r?"/":s?"./":".":(s&&(n+="/"),r?`/${n}`:n)},isAbsolute(n){return m(n,"path"),n.length>0&&n.charCodeAt(0)===o},join(...n){if(n.length===0)return".";let r;for(let s=0;s<n.length;++s){const d=n[s];m(d,"path"),d.length>0&&(r===void 0?r=d:r+=`/${d}`)}return r===void 0?".":t.posix.normalize(r)},relative(n,r){if(m(n,"from"),m(r,"to"),n===r||(n=t.posix.resolve(n),r=t.posix.resolve(r),n===r))return"";const s=1,d=n.length,C=d-s,b=1,N=r.length-b,w=C<N?C:N;let y=-1,M=0;for(;M<w;M++){const D=n.charCodeAt(s+M);if(D!==r.charCodeAt(b+M))break;D===o&&(y=M)}if(M===w)if(N>w){if(r.charCodeAt(b+M)===o)return r.slice(b+M+1);if(M===0)return r.slice(b+M)}else C>w&&(n.charCodeAt(s+M)===o?y=M:M===0&&(y=0));let U="";for(M=s+y+1;M<=d;++M)(M===d||n.charCodeAt(M)===o)&&(U+=U.length===0?"..":"/..");return`${U}${r.slice(b+y)}`},toNamespacedPath(n){return n},dirname(n){if(m(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===o;let s=-1,d=!0;for(let C=n.length-1;C>=1;--C)if(n.charCodeAt(C)===o){if(!d){s=C;break}}else d=!1;return s===-1?r?"/":".":r&&s===1?"//":n.slice(0,s)},basename(n,r){r!==void 0&&m(r,"ext"),m(n,"path");let s=0,d=-1,C=!0,b;if(r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let N=r.length-1,w=-1;for(b=n.length-1;b>=0;--b){const y=n.charCodeAt(b);if(y===o){if(!C){s=b+1;break}}else w===-1&&(C=!1,w=b+1),N>=0&&(y===r.charCodeAt(N)?--N==-1&&(d=b):(N=-1,d=w))}return s===d?d=w:d===-1&&(d=n.length),n.slice(s,d)}for(b=n.length-1;b>=0;--b)if(n.charCodeAt(b)===o){if(!C){s=b+1;break}}else d===-1&&(C=!1,d=b+1);return d===-1?"":n.slice(s,d)},extname(n){m(n,"path");let r=-1,s=0,d=-1,C=!0,b=0;for(let N=n.length-1;N>=0;--N){const w=n.charCodeAt(N);if(w===o){if(!C){s=N+1;break}continue}d===-1&&(C=!1,d=N+1),w===a?r===-1?r=N:b!==1&&(b=1):r!==-1&&(b=-1)}return r===-1||d===-1||b===0||b===1&&r===d-1&&r===s+1?"":n.slice(r,d)},format:L.bind(null,"/"),parse(n){m(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const s=n.charCodeAt(0)===o;let d;s?(r.root="/",d=1):d=0;let C=-1,b=0,N=-1,w=!0,y=n.length-1,M=0;for(;y>=d;--y){const U=n.charCodeAt(y);if(U===o){if(!w){b=y+1;break}continue}N===-1&&(w=!1,N=y+1),U===a?C===-1?C=y:M!==1&&(M=1):C!==-1&&(M=-1)}if(N!==-1){const U=b===0&&s?1:b;C===-1||M===0||M===1&&C===N-1&&C===b+1?r.base=r.name=n.slice(U,N):(r.name=n.slice(U,C),r.base=n.slice(U,N),r.ext=n.slice(C,N))}return b>0?r.dir=n.slice(0,b-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=E.platform==="win32"?t.win32.normalize:t.posix.normalize,t.resolve=E.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=E.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=E.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=E.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=E.platform==="win32"?t.win32.extname:t.posix.extname,t.sep=E.platform==="win32"?t.win32.sep:t.posix.sep}),Y(z[8],G([0,1,2]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const P=E.globals.performance&&typeof E.globals.performance.now=="function";class A{constructor(h){this._highResolution=P&&h,this._startTime=this._now(),this._stopTime=-1}static create(h=!0){return new A(h)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}t.StopWatch=A}),Y(z[9],G([0,1,4,7,18,8]),function(I,t,E,P,A,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.DebounceEmitter=t.PauseableEmitter=t.Emitter=t.Event=void 0;var h;(function(i){i.None=()=>P.Disposable.None;function u(k){return(T,O=null,H)=>{let e=!1,B;return B=k(Q=>{if(!e)return B?B.dispose():e=!0,T.call(O,Q)},null,H),e&&B.dispose(),B}}i.once=u;function _(k,T){return C((O,H=null,e)=>k(B=>O.call(H,T(B)),null,e))}i.map=_;function L(k,T){return C((O,H=null,e)=>k(B=>{T(B),O.call(H,B)},null,e))}i.forEach=L;function n(k,T){return C((O,H=null,e)=>k(B=>T(B)&&O.call(H,B),null,e))}i.filter=n;function r(k){return k}i.signal=r;function s(...k){return(T,O=null,H)=>(0,P.combinedDisposable)(...k.map(e=>e(B=>T.call(O,B),null,H)))}i.any=s;function d(k,T,O){let H=O;return _(k,e=>(H=T(H,e),H))}i.reduce=d;function C(k){let T;const O=new S({onFirstListenerAdd(){T=k(O.fire,O)},onLastListenerRemove(){T.dispose()}});return O.event}function b(k,T,O=100,H=!1,e){let B,Q,Z,ie=0;const re=new S({leakWarningThreshold:e,onFirstListenerAdd(){B=k(le=>{ie++,Q=T(Q,le),H&&!Z&&(re.fire(Q),Q=void 0),clearTimeout(Z),Z=setTimeout(()=>{const oe=Q;Q=void 0,Z=void 0,(!H||ie>1)&&re.fire(oe),ie=0},O)})},onLastListenerRemove(){B.dispose()}});return re.event}i.debounce=b;function N(k,T=(O,H)=>O===H){let O=!0,H;return n(k,e=>{const B=O||!T(e,H);return O=!1,H=e,B})}i.latch=N;function w(k,T){return[i.filter(k,T),i.filter(k,O=>!T(O))]}i.split=w;function y(k,T=!1,O=[]){let H=O.slice(),e=k(Z=>{H?H.push(Z):Q.fire(Z)});const B=()=>{H&&H.forEach(Z=>Q.fire(Z)),H=null},Q=new S({onFirstListenerAdd(){e||(e=k(Z=>Q.fire(Z)))},onFirstListenerDidAdd(){H&&(T?setTimeout(B):B())},onLastListenerRemove(){e&&e.dispose(),e=null}});return Q.event}i.buffer=y;class M{constructor(T){this.event=T}map(T){return new M(_(this.event,T))}forEach(T){return new M(L(this.event,T))}filter(T){return new M(n(this.event,T))}reduce(T,O){return new M(d(this.event,T,O))}latch(){return new M(N(this.event))}debounce(T,O=100,H=!1,e){return new M(b(this.event,T,O,H,e))}on(T,O,H){return this.event(T,O,H)}once(T,O,H){return u(this.event)(T,O,H)}}function U(k){return new M(k)}i.chain=U;function D(k,T,O=H=>H){const H=(...Z)=>Q.fire(O(...Z)),e=()=>k.on(T,H),B=()=>k.removeListener(T,H),Q=new S({onFirstListenerAdd:e,onLastListenerRemove:B});return Q.event}i.fromNodeEventEmitter=D;function q(k,T,O=H=>H){const H=(...Z)=>Q.fire(O(...Z)),e=()=>k.addEventListener(T,H),B=()=>k.removeEventListener(T,H),Q=new S({onFirstListenerAdd:e,onLastListenerRemove:B});return Q.event}i.fromDOMEventEmitter=q;function V(k){return new Promise(T=>u(k)(T))}i.toPromise=V})(h=t.Event||(t.Event={}));class a{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${a._idPool++}`}start(u){this._stopWatch=new l.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}a._idPool=0;let o=-1;class f{constructor(u,_=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=_,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let _=o;if(typeof this.customThreshold=="number"&&(_=this.customThreshold),_<=0||u<_)return;this._stacks||(this._stacks=new Map);const L=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(L)||0;if(this._stacks.set(L,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=_*.5;let r,s=0;for(const[d,C]of this._stacks)(!r||s<C)&&(r=d,s=C);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${s}):`),console.warn(r)}return()=>{const r=this._stacks.get(L)||0;this._stacks.set(L,r-1)}}}class S{constructor(u){var _;this._disposed=!1,this._options=u,this._leakageMon=o>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((_=this._options)===null||_===void 0?void 0:_._profName)?new a(this._options._profName):void 0}get event(){return this._event||(this._event=(u,_,L)=>{var n;this._listeners||(this._listeners=new A.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(_?[u,_]:u);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,_);const d=(n=this._leakageMon)===null||n===void 0?void 0:n.check(this._listeners.size),C=(0,P.toDisposable)(()=>{d&&d(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return L instanceof P.DisposableStore?L.add(C):Array.isArray(L)&&L.push(C),C}),this._event}fire(u){var _,L;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,u]);for((_=this._perfMon)===null||_===void 0||_.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,r]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,r):n[0].call(n[1],r)}catch(s){(0,E.onUnexpectedError)(s)}}(L=this._perfMon)===null||L===void 0||L.stop()}}dispose(){var u,_,L,n,r;this._disposed||(this._disposed=!0,(u=this._listeners)===null||u===void 0||u.clear(),(_=this._deliveryQueue)===null||_===void 0||_.clear(),(n=(L=this._options)===null||L===void 0?void 0:L.onLastListenerRemove)===null||n===void 0||n.call(L),(r=this._leakageMon)===null||r===void 0||r.dispose())}}t.Emitter=S;class c extends S{constructor(u){super(u);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=u==null?void 0:u.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}t.PauseableEmitter=c;class g extends c{constructor(u){var _;super(u);this._delay=(_=u.delay)!==null&&_!==void 0?_:100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}t.DebounceEmitter=g;class m{constructor(){this.buffers=[]}wrapEvent(u){return(_,L,n)=>u(r=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>_.call(L,r)):_.call(L,r)},void 0,n)}bufferEvents(u){const _=[];this.buffers.push(_);const L=u();return this.buffers.pop(),_.forEach(n=>n()),L}}t.EventBufferer=m;class v{constructor(){this.listening=!1,this.inputEvent=h.None,this.inputEventListener=P.Disposable.None,this.emitter=new S({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=v}),Y(z[21],G([0,1,9]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const P=Object.freeze(function(a,o){const f=setTimeout(a.bind(o),0);return{dispose(){clearTimeout(f)}}});var A;(function(a){function o(f){return f===a.None||f===a.Cancelled||f instanceof l?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}a.isCancellationToken=o,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(A=t.CancellationToken||(t.CancellationToken={}));class l{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?P:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class h{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new l),this._token}cancel(){this._token?this._token instanceof l&&this._token.cancel():this._token=A.Cancelled}dispose(o=!1){o&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof l&&this._token.dispose():this._token=A.None}}t.CancellationTokenSource=h}),Y(z[5],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLeftDeleteOffset=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.containsUppercaseCharacter=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.escapeRegExpCharacters=t.escape=t.format=t.isFalsyOrWhitespace=void 0;function E(p){return!p||typeof p!="string"?!0:p.trim().length===0}t.isFalsyOrWhitespace=E;const P=/{(\d+)}/g;function A(p,...R){return R.length===0?p:p.replace(P,function(F,W){const j=parseInt(W,10);return isNaN(j)||j<0||j>=R.length?F:R[j]})}t.format=A;function l(p){return p.replace(/[<>&]/g,function(R){switch(R){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return R}})}t.escape=l;function h(p){return p.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=h;function a(p,R=" "){const F=o(p,R);return f(F,R)}t.trim=a;function o(p,R){if(!p||!R)return p;const F=R.length;if(F===0||p.length===0)return p;let W=0;for(;p.indexOf(R,W)===W;)W=W+F;return p.substring(W)}t.ltrim=o;function f(p,R){if(!p||!R)return p;const F=R.length,W=p.length;if(F===0||W===0)return p;let j=W,$=-1;for(;$=p.lastIndexOf(R,j-1),!($===-1||$+F!==j);){if($===0)return"";j=$}return p.substring(0,j)}t.rtrim=f;function S(p){return p.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=S;function c(p){return p.replace(/\*/g,"")}t.stripWildcards=c;function g(p,R,F={}){if(!p)throw new Error("Cannot create regex from empty string");R||(p=h(p)),F.wholeWord&&(/\B/.test(p.charAt(0))||(p="\\b"+p),/\B/.test(p.charAt(p.length-1))||(p=p+"\\b"));let W="";return F.global&&(W+="g"),F.matchCase||(W+="i"),F.multiline&&(W+="m"),F.unicode&&(W+="u"),new RegExp(p,W)}t.createRegExp=g;function m(p){return p.source==="^"||p.source==="^$"||p.source==="$"||p.source==="^\\s*$"?!1:!!(p.exec("")&&p.lastIndex===0)}t.regExpLeadsToEndlessLoop=m;function v(p){return(p.global?"g":"")+(p.ignoreCase?"i":"")+(p.multiline?"m":"")+(p.unicode?"u":"")}t.regExpFlags=v;function i(p){return p.split(/\r\n|\r|\n/)}t.splitLines=i;function u(p){for(let R=0,F=p.length;R<F;R++){const W=p.charCodeAt(R);if(W!==32&&W!==9)return R}return-1}t.firstNonWhitespaceIndex=u;function _(p,R=0,F=p.length){for(let W=R;W<F;W++){const j=p.charCodeAt(W);if(j!==32&&j!==9)return p.substring(R,W)}return p.substring(R,F)}t.getLeadingWhitespace=_;function L(p,R=p.length-1){for(let F=R;F>=0;F--){const W=p.charCodeAt(F);if(W!==32&&W!==9)return F}return-1}t.lastNonWhitespaceIndex=L;function n(p,R){return p<R?-1:p>R?1:0}t.compare=n;function r(p,R,F=0,W=p.length,j=0,$=R.length){for(;F<W&&j<$;F++,j++){let K=p.charCodeAt(F),te=R.charCodeAt(j);if(K<te)return-1;if(K>te)return 1}const J=W-F,x=$-j;return J<x?-1:J>x?1:0}t.compareSubstring=r;function s(p,R){return d(p,R,0,p.length,0,R.length)}t.compareIgnoreCase=s;function d(p,R,F=0,W=p.length,j=0,$=R.length){for(;F<W&&j<$;F++,j++){let K=p.charCodeAt(F),te=R.charCodeAt(j);if(K===te)continue;const ae=K-te;if(!(ae===32&&b(te))&&!(ae===-32&&b(K)))return C(K)&&C(te)?ae:r(p.toLowerCase(),R.toLowerCase(),F,W,j,$)}const J=W-F,x=$-j;return J<x?-1:J>x?1:0}t.compareSubstringIgnoreCase=d;function C(p){return p>=97&&p<=122}t.isLowerAsciiLetter=C;function b(p){return p>=65&&p<=90}t.isUpperAsciiLetter=b;function N(p){return C(p)||b(p)}function w(p,R){return p.length===R.length&&y(p,R)}t.equalsIgnoreCase=w;function y(p,R,F=p.length){for(let W=0;W<F;W++){const j=p.charCodeAt(W),$=R.charCodeAt(W);if(j!==$){if(N(j)&&N($)){const J=Math.abs(j-$);if(J!==0&&J!==32)return!1}else if(String.fromCharCode(j).toLowerCase()!==String.fromCharCode($).toLowerCase())return!1}}return!0}function M(p,R){const F=R.length;return R.length>p.length?!1:y(p,R,F)}t.startsWithIgnoreCase=M;function U(p,R){let F,W=Math.min(p.length,R.length);for(F=0;F<W;F++)if(p.charCodeAt(F)!==R.charCodeAt(F))return F;return W}t.commonPrefixLength=U;function D(p,R){let F,W=Math.min(p.length,R.length);const j=p.length-1,$=R.length-1;for(F=0;F<W;F++)if(p.charCodeAt(j-F)!==R.charCodeAt($-F))return F;return W}t.commonSuffixLength=D;function q(p){return 55296<=p&&p<=56319}t.isHighSurrogate=q;function V(p){return 56320<=p&&p<=57343}t.isLowSurrogate=V;function k(p,R){return(p-55296<<10)+(R-56320)+65536}t.computeCodePoint=k;function T(p,R,F){const W=p.charCodeAt(F);if(q(W)&&F+1<R){const j=p.charCodeAt(F+1);if(V(j))return k(W,j)}return W}t.getNextCodePoint=T;function O(p,R){const F=p.charCodeAt(R-1);if(V(F)&&R>1){const W=p.charCodeAt(R-2);if(q(W))return k(W,F)}return F}function H(p,R){const F=ee.getInstance(),W=R,j=p.length,$=T(p,j,R);R+=$>=65536?2:1;let J=F.getGraphemeBreakType($);for(;R<j;){const x=T(p,j,R),K=F.getGraphemeBreakType(x);if(ue(J,K))break;R+=x>=65536?2:1,J=K}return R-W}t.nextCharLength=H;function e(p,R){const F=ee.getInstance(),W=R,j=O(p,R);R-=j>=65536?2:1;let $=F.getGraphemeBreakType(j);for(;R>0;){const J=O(p,R),x=F.getGraphemeBreakType(J);if(ue(x,$))break;R-=J>=65536?2:1,$=x}return W-R}t.prevCharLength=e;function B(p){const R=p.byteLength,F=[];let W=0;for(;W<R;){const j=p[W];let $;if(j>=240&&W+3<R?$=(p[W++]&7)<<18>>>0|(p[W++]&63)<<12>>>0|(p[W++]&63)<<6>>>0|(p[W++]&63)<<0>>>0:j>=224&&W+2<R?$=(p[W++]&15)<<12>>>0|(p[W++]&63)<<6>>>0|(p[W++]&63)<<0>>>0:j>=192&&W+1<R?$=(p[W++]&31)<<6>>>0|(p[W++]&63)<<0>>>0:$=p[W++],$>=0&&$<=55295||$>=57344&&$<=65535)F.push(String.fromCharCode($));else if($>=65536&&$<=1114111){const J=$-65536,x=55296+((J&1047552)>>>10),K=56320+((J&1023)>>>0);F.push(String.fromCharCode(x)),F.push(String.fromCharCode(K))}else F.push(String.fromCharCode(65533))}return F.join("")}t.decodeUTF8=B;const Q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Z(p){return Q.test(p)}t.containsRTL=Z;const ie=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function re(p){return ie.test(p)}t.containsEmoji=re;const le=/^[\t\n\r\x20-\x7E]*$/;function oe(p){return le.test(p)}t.isBasicASCII=oe,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function me(p){return t.UNUSUAL_LINE_TERMINATORS.test(p)}t.containsUnusualLineTerminators=me;function ge(p){for(let R=0,F=p.length;R<F;R++)if(ce(p.charCodeAt(R)))return!0;return!1}t.containsFullWidthCharacter=ge;function ce(p){return p=+p,p>=11904&&p<=55215||p>=63744&&p<=64255||p>=65281&&p<=65374}t.isFullWidthCharacter=ce;function fe(p){return p>=127462&&p<=127487||p===8986||p===8987||p===9200||p===9203||p>=9728&&p<=10175||p===11088||p===11093||p>=127744&&p<=128591||p>=128640&&p<=128764||p>=128992&&p<=129003||p>=129280&&p<=129535||p>=129648&&p<=129750}t.isEmojiImprecise=fe,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function _e(p){return!!(p&&p.length>0&&p.charCodeAt(0)===65279)}t.startsWithUTF8BOM=_e;function ve(p,R=!1){return p?(R&&(p=p.replace(/\\./g,"")),p.toLowerCase()!==p):!1}t.containsUppercaseCharacter=ve;function Ce(p){const R=90-65+1;return p=p%(2*R),p<R?String.fromCharCode(97+p):String.fromCharCode(65+p-R)}t.singleLetterHash=Ce;function be(p){return ee.getInstance().getGraphemeBreakType(p)}t.getGraphemeBreakType=be;function ue(p,R){return p===0?R!==5&&R!==7:p===2&&R===3?!1:p===4||p===2||p===3||R===4||R===2||R===3?!0:!(p===8&&(R===8||R===9||R===11||R===12)||(p===11||p===9)&&(R===9||R===10)||(p===12||p===10)&&R===10||R===5||R===13||R===7||p===1||p===13&&R===14||p===6&&R===6)}t.breakBetweenGraphemeBreakType=ue;class ee{constructor(){this._data=Se()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(R){if(R<32)return R===10?3:R===13?2:4;if(R<127)return 0;const F=this._data,W=F.length/3;let j=1;for(;j<=W;)if(R<F[3*j])j=2*j;else if(R>F[3*j+1])j=2*j+1;else return F[3*j+2];return 0}}ee._INSTANCE=null;function Se(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Le(p,R){if(p===0)return 0;const F=Ne(p,R);if(F!==void 0)return F;const W=O(R,p);return p-=se(W),p}t.getLeftDeleteOffset=Le;function Ne(p,R){let F=O(R,p);for(p-=se(F);we(F)||F===65039||F===8419;){if(p===0)return;F=O(R,p),p-=se(F)}if(!!fe(F)){if(p>=0){const W=O(R,p);W===8205&&(p-=se(W))}return p}}function se(p){return p>=65536?2:1}function we(p){return 127995<=p&&p<=127999}}),Y(z[22],G([0,1,5]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.stringHash=t.doHash=t.hash=void 0;function P(i){return A(i,0)}t.hash=P;function A(i,u){switch(typeof i){case"object":return i===null?l(349,u):Array.isArray(i)?o(i,u):f(i,u);case"string":return a(i,u);case"boolean":return h(i,u);case"number":return l(i,u);case"undefined":return l(937,u);default:return l(617,u)}}t.doHash=A;function l(i,u){return(u<<5)-u+i|0}function h(i,u){return l(i?433:863,u)}function a(i,u){u=l(149417,u);for(let _=0,L=i.length;_<L;_++)u=l(i.charCodeAt(_),u);return u}t.stringHash=a;function o(i,u){return u=l(104579,u),i.reduce((_,L)=>A(L,_),u)}function f(i,u){return u=l(181387,u),Object.keys(i).sort().reduce((_,L)=>(_=a(L,_),A(i[L],_)),u)}function S(i,u,_=32){const L=_-u,n=~((1<<L)-1);return(i<<u|(n&i)>>>L)>>>0}function c(i,u=0,_=i.byteLength,L=0){for(let n=0;n<_;n++)i[u+n]=L}function g(i,u,_="0"){for(;i.length<u;)i=_+i;return i}function m(i,u=32){return i instanceof ArrayBuffer?Array.from(new Uint8Array(i)).map(_=>_.toString(16).padStart(2,"0")).join(""):g((i>>>0).toString(16),u/4)}t.toHexString=m;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const _=u.length;if(_===0)return;const L=this._buff;let n=this._buffLen,r=this._leftoverHighSurrogate,s,d;for(r!==0?(s=r,d=-1,r=0):(s=u.charCodeAt(0),d=0);;){let C=s;if(E.isHighSurrogate(s))if(d+1<_){const b=u.charCodeAt(d+1);E.isLowSurrogate(b)?(d++,C=E.computeCodePoint(s,b)):C=65533}else{r=s;break}else E.isLowSurrogate(s)&&(C=65533);if(n=this._push(L,n,C),d++,d<_)s=u.charCodeAt(d);else break}this._buffLen=n,this._leftoverHighSurrogate=r}_push(u,_,L){return L<128?u[_++]=L:L<2048?(u[_++]=192|(L&1984)>>>6,u[_++]=128|(L&63)>>>0):L<65536?(u[_++]=224|(L&61440)>>>12,u[_++]=128|(L&4032)>>>6,u[_++]=128|(L&63)>>>0):(u[_++]=240|(L&1835008)>>>18,u[_++]=128|(L&258048)>>>12,u[_++]=128|(L&4032)>>>6,u[_++]=128|(L&63)>>>0),_>=64&&(this._step(),_-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),_}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=v._bigBlock32,_=this._buffDV;for(let w=0;w<64;w+=4)u.setUint32(w,_.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)u.setUint32(w,S(u.getUint32(w-12,!1)^u.getUint32(w-32,!1)^u.getUint32(w-56,!1)^u.getUint32(w-64,!1),1),!1);let L=this._h0,n=this._h1,r=this._h2,s=this._h3,d=this._h4,C,b,N;for(let w=0;w<80;w++)w<20?(C=n&r|~n&s,b=1518500249):w<40?(C=n^r^s,b=1859775393):w<60?(C=n&r|n&s|r&s,b=2400959708):(C=n^r^s,b=3395469782),N=S(L,5)+C+d+b+u.getUint32(w*4,!1)&4294967295,d=s,s=r,r=S(n,30),n=L,L=N;this._h0=this._h0+L&4294967295,this._h1=this._h1+n&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+d&4294967295}}t.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(z[10],G([0,1,14,22]),function(I,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class A{constructor(c){this.source=c}getElements(){const c=this.source,g=new Int32Array(c.length);for(let m=0,v=c.length;m<v;m++)g[m]=c.charCodeAt(m);return g}}t.StringDiffSequence=A;function l(S,c,g){return new f(new A(S),new A(c)).ComputeDiff(g).changes}t.stringDiff=l;class h{static Assert(c,g){if(!c)throw new Error(g)}}t.Debug=h;class a{static Copy(c,g,m,v,i){for(let u=0;u<i;u++)m[v+u]=c[g+u]}static Copy2(c,g,m,v,i){for(let u=0;u<i;u++)m[v+u]=c[g+u]}}t.MyArray=a;class o{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(c,g){this.m_originalStart=Math.min(this.m_originalStart,c),this.m_modifiedStart=Math.min(this.m_modifiedStart,g),this.m_originalCount++}AddModifiedElement(c,g){this.m_originalStart=Math.min(this.m_originalStart,c),this.m_modifiedStart=Math.min(this.m_modifiedStart,g),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class f{constructor(c,g,m=null){this.ContinueProcessingPredicate=m,this._originalSequence=c,this._modifiedSequence=g;const[v,i,u]=f._getElements(c),[_,L,n]=f._getElements(g);this._hasStrings=u&&n,this._originalStringElements=v,this._originalElementsOrHash=i,this._modifiedStringElements=_,this._modifiedElementsOrHash=L,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(c){return c.length>0&&typeof c[0]=="string"}static _getElements(c){const g=c.getElements();if(f._isStringArray(g)){const m=new Int32Array(g.length);for(let v=0,i=g.length;v<i;v++)m[v]=(0,P.stringHash)(g[v],0);return[g,m,!0]}return g instanceof Int32Array?[[],g,!1]:[[],new Int32Array(g),!1]}ElementsAreEqual(c,g){return this._originalElementsOrHash[c]!==this._modifiedElementsOrHash[g]?!1:this._hasStrings?this._originalStringElements[c]===this._modifiedStringElements[g]:!0}ElementsAreStrictEqual(c,g){if(!this.ElementsAreEqual(c,g))return!1;const m=f._getStrictElement(this._originalSequence,c),v=f._getStrictElement(this._modifiedSequence,g);return m===v}static _getStrictElement(c,g){return typeof c.getStrictElement=="function"?c.getStrictElement(g):null}OriginalElementsAreEqual(c,g){return this._originalElementsOrHash[c]!==this._originalElementsOrHash[g]?!1:this._hasStrings?this._originalStringElements[c]===this._originalStringElements[g]:!0}ModifiedElementsAreEqual(c,g){return this._modifiedElementsOrHash[c]!==this._modifiedElementsOrHash[g]?!1:this._hasStrings?this._modifiedStringElements[c]===this._modifiedStringElements[g]:!0}ComputeDiff(c){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,c)}_ComputeDiff(c,g,m,v,i){const u=[!1];let _=this.ComputeDiffRecursive(c,g,m,v,u);return i&&(_=this.PrettifyChanges(_)),{quitEarly:u[0],changes:_}}ComputeDiffRecursive(c,g,m,v,i){for(i[0]=!1;c<=g&&m<=v&&this.ElementsAreEqual(c,m);)c++,m++;for(;g>=c&&v>=m&&this.ElementsAreEqual(g,v);)g--,v--;if(c>g||m>v){let s;return m<=v?(h.Assert(c===g+1,"originalStart should only be one more than originalEnd"),s=[new E.DiffChange(c,0,m,v-m+1)]):c<=g?(h.Assert(m===v+1,"modifiedStart should only be one more than modifiedEnd"),s=[new E.DiffChange(c,g-c+1,m,0)]):(h.Assert(c===g+1,"originalStart should only be one more than originalEnd"),h.Assert(m===v+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}const u=[0],_=[0],L=this.ComputeRecursionPoint(c,g,m,v,u,_,i),n=u[0],r=_[0];if(L!==null)return L;if(!i[0]){const s=this.ComputeDiffRecursive(c,n,m,r,i);let d=[];return i[0]?d=[new E.DiffChange(n+1,g-(n+1)+1,r+1,v-(r+1)+1)]:d=this.ComputeDiffRecursive(n+1,g,r+1,v,i),this.ConcatenateChanges(s,d)}return[new E.DiffChange(c,g-c+1,m,v-m+1)]}WALKTRACE(c,g,m,v,i,u,_,L,n,r,s,d,C,b,N,w,y,M){let U=null,D=null,q=new o,V=g,k=m,T=C[0]-w[0]-v,O=-1073741824,H=this.m_forwardHistory.length-1;do{const e=T+c;e===V||e<k&&n[e-1]<n[e+1]?(s=n[e+1],b=s-T-v,s<O&&q.MarkNextChange(),O=s,q.AddModifiedElement(s+1,b),T=e+1-c):(s=n[e-1]+1,b=s-T-v,s<O&&q.MarkNextChange(),O=s-1,q.AddOriginalElement(s,b+1),T=e-1-c),H>=0&&(n=this.m_forwardHistory[H],c=n[0],V=1,k=n.length-1)}while(--H>=-1);if(U=q.getReverseChanges(),M[0]){let e=C[0]+1,B=w[0]+1;if(U!==null&&U.length>0){const Q=U[U.length-1];e=Math.max(e,Q.getOriginalEnd()),B=Math.max(B,Q.getModifiedEnd())}D=[new E.DiffChange(e,d-e+1,B,N-B+1)]}else{q=new o,V=u,k=_,T=C[0]-w[0]-L,O=1073741824,H=y?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const e=T+i;e===V||e<k&&r[e-1]>=r[e+1]?(s=r[e+1]-1,b=s-T-L,s>O&&q.MarkNextChange(),O=s+1,q.AddOriginalElement(s+1,b+1),T=e+1-i):(s=r[e-1],b=s-T-L,s>O&&q.MarkNextChange(),O=s,q.AddModifiedElement(s+1,b+1),T=e-1-i),H>=0&&(r=this.m_reverseHistory[H],i=r[0],V=1,k=r.length-1)}while(--H>=-1);D=q.getChanges()}return this.ConcatenateChanges(U,D)}ComputeRecursionPoint(c,g,m,v,i,u,_){let L=0,n=0,r=0,s=0,d=0,C=0;c--,m--,i[0]=0,u[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const b=g-c+(v-m),N=b+1,w=new Int32Array(N),y=new Int32Array(N),M=v-m,U=g-c,D=c-m,q=g-v,k=(U-M)%2==0;w[M]=c,y[U]=g,_[0]=!1;for(let T=1;T<=b/2+1;T++){let O=0,H=0;r=this.ClipDiagonalBound(M-T,T,M,N),s=this.ClipDiagonalBound(M+T,T,M,N);for(let B=r;B<=s;B+=2){B===r||B<s&&w[B-1]<w[B+1]?L=w[B+1]:L=w[B-1]+1,n=L-(B-M)-D;const Q=L;for(;L<g&&n<v&&this.ElementsAreEqual(L+1,n+1);)L++,n++;if(w[B]=L,L+n>O+H&&(O=L,H=n),!k&&Math.abs(B-U)<=T-1&&L>=y[B])return i[0]=L,u[0]=n,Q<=y[B]&&1447>0&&T<=1447+1?this.WALKTRACE(M,r,s,D,U,d,C,q,w,y,L,g,i,n,v,u,k,_):null}const e=(O-c+(H-m)-T)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(O,e))return _[0]=!0,i[0]=O,u[0]=H,e>0&&1447>0&&T<=1447+1?this.WALKTRACE(M,r,s,D,U,d,C,q,w,y,L,g,i,n,v,u,k,_):(c++,m++,[new E.DiffChange(c,g-c+1,m,v-m+1)]);d=this.ClipDiagonalBound(U-T,T,U,N),C=this.ClipDiagonalBound(U+T,T,U,N);for(let B=d;B<=C;B+=2){B===d||B<C&&y[B-1]>=y[B+1]?L=y[B+1]-1:L=y[B-1],n=L-(B-U)-q;const Q=L;for(;L>c&&n>m&&this.ElementsAreEqual(L,n);)L--,n--;if(y[B]=L,k&&Math.abs(B-M)<=T&&L<=w[B])return i[0]=L,u[0]=n,Q>=w[B]&&1447>0&&T<=1447+1?this.WALKTRACE(M,r,s,D,U,d,C,q,w,y,L,g,i,n,v,u,k,_):null}if(T<=1447){let B=new Int32Array(s-r+2);B[0]=M-r+1,a.Copy2(w,r,B,1,s-r+1),this.m_forwardHistory.push(B),B=new Int32Array(C-d+2),B[0]=U-d+1,a.Copy2(y,d,B,1,C-d+1),this.m_reverseHistory.push(B)}}return this.WALKTRACE(M,r,s,D,U,d,C,q,w,y,L,g,i,n,v,u,k,_)}PrettifyChanges(c){for(let g=0;g<c.length;g++){const m=c[g],v=g<c.length-1?c[g+1].originalStart:this._originalElementsOrHash.length,i=g<c.length-1?c[g+1].modifiedStart:this._modifiedElementsOrHash.length,u=m.originalLength>0,_=m.modifiedLength>0;for(;m.originalStart+m.originalLength<v&&m.modifiedStart+m.modifiedLength<i&&(!u||this.OriginalElementsAreEqual(m.originalStart,m.originalStart+m.originalLength))&&(!_||this.ModifiedElementsAreEqual(m.modifiedStart,m.modifiedStart+m.modifiedLength));){const n=this.ElementsAreStrictEqual(m.originalStart,m.modifiedStart);if(this.ElementsAreStrictEqual(m.originalStart+m.originalLength,m.modifiedStart+m.modifiedLength)&&!n)break;m.originalStart++,m.modifiedStart++}let L=[null];if(g<c.length-1&&this.ChangesOverlap(c[g],c[g+1],L)){c[g]=L[0],c.splice(g+1,1),g--;continue}}for(let g=c.length-1;g>=0;g--){const m=c[g];let v=0,i=0;if(g>0){const s=c[g-1];v=s.originalStart+s.originalLength,i=s.modifiedStart+s.modifiedLength}const u=m.originalLength>0,_=m.modifiedLength>0;let L=0,n=this._boundaryScore(m.originalStart,m.originalLength,m.modifiedStart,m.modifiedLength);for(let s=1;;s++){const d=m.originalStart-s,C=m.modifiedStart-s;if(d<v||C<i||u&&!this.OriginalElementsAreEqual(d,d+m.originalLength)||_&&!this.ModifiedElementsAreEqual(C,C+m.modifiedLength))break;const N=(d===v&&C===i?5:0)+this._boundaryScore(d,m.originalLength,C,m.modifiedLength);N>n&&(n=N,L=s)}m.originalStart-=L,m.modifiedStart-=L;const r=[null];if(g>0&&this.ChangesOverlap(c[g-1],c[g],r)){c[g-1]=r[0],c.splice(g,1),g++;continue}}if(this._hasStrings)for(let g=1,m=c.length;g<m;g++){const v=c[g-1],i=c[g],u=i.originalStart-v.originalStart-v.originalLength,_=v.originalStart,L=i.originalStart+i.originalLength,n=L-_,r=v.modifiedStart,s=i.modifiedStart+i.modifiedLength,d=s-r;if(u<5&&n<20&&d<20){const C=this._findBetterContiguousSequence(_,n,r,d,u);if(C){const[b,N]=C;(b!==v.originalStart+v.originalLength||N!==v.modifiedStart+v.modifiedLength)&&(v.originalLength=b-v.originalStart,v.modifiedLength=N-v.modifiedStart,i.originalStart=b+u,i.modifiedStart=N+u,i.originalLength=L-i.originalStart,i.modifiedLength=s-i.modifiedStart)}}}return c}_findBetterContiguousSequence(c,g,m,v,i){if(g<i||v<i)return null;const u=c+g-i+1,_=m+v-i+1;let L=0,n=0,r=0;for(let s=c;s<u;s++)for(let d=m;d<_;d++){const C=this._contiguousSequenceScore(s,d,i);C>0&&C>L&&(L=C,n=s,r=d)}return L>0?[n,r]:null}_contiguousSequenceScore(c,g,m){let v=0;for(let i=0;i<m;i++){if(!this.ElementsAreEqual(c+i,g+i))return 0;v+=this._originalStringElements[c+i].length}return v}_OriginalIsBoundary(c){return c<=0||c>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[c])}_OriginalRegionIsBoundary(c,g){if(this._OriginalIsBoundary(c)||this._OriginalIsBoundary(c-1))return!0;if(g>0){const m=c+g;if(this._OriginalIsBoundary(m-1)||this._OriginalIsBoundary(m))return!0}return!1}_ModifiedIsBoundary(c){return c<=0||c>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[c])}_ModifiedRegionIsBoundary(c,g){if(this._ModifiedIsBoundary(c)||this._ModifiedIsBoundary(c-1))return!0;if(g>0){const m=c+g;if(this._ModifiedIsBoundary(m-1)||this._ModifiedIsBoundary(m))return!0}return!1}_boundaryScore(c,g,m,v){const i=this._OriginalRegionIsBoundary(c,g)?1:0,u=this._ModifiedRegionIsBoundary(m,v)?1:0;return i+u}ConcatenateChanges(c,g){let m=[];if(c.length===0||g.length===0)return g.length>0?g:c;if(this.ChangesOverlap(c[c.length-1],g[0],m)){const v=new Array(c.length+g.length-1);return a.Copy(c,0,v,0,c.length-1),v[c.length-1]=m[0],a.Copy(g,1,v,c.length,g.length-1),v}else{const v=new Array(c.length+g.length);return a.Copy(c,0,v,0,c.length),a.Copy(g,0,v,c.length,g.length),v}}ChangesOverlap(c,g,m){if(h.Assert(c.originalStart<=g.originalStart,"Left change is not less than or equal to right change"),h.Assert(c.modifiedStart<=g.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=g.originalStart||c.modifiedStart+c.modifiedLength>=g.modifiedStart){const v=c.originalStart;let i=c.originalLength;const u=c.modifiedStart;let _=c.modifiedLength;return c.originalStart+c.originalLength>=g.originalStart&&(i=g.originalStart+g.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=g.modifiedStart&&(_=g.modifiedStart+g.modifiedLength-c.modifiedStart),m[0]=new E.DiffChange(v,i,u,_),!0}else return m[0]=null,!1}ClipDiagonalBound(c,g,m,v){if(c>=0&&c<v)return c;const i=m,u=v-m-1,_=g%2==0;if(c<0){const L=i%2==0;return _===L?0:1}else{const L=u%2==0;return _===L?v-1:v-2}}}t.LcsDiff=f}),Y(z[11],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.isFunction=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isUndefined=t.isBoolean=t.isNumber=t.isObject=t.isString=t.isArray=void 0;function E(n){return Array.isArray(n)}t.isArray=E;function P(n){return typeof n=="string"}t.isString=P;function A(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}t.isObject=A;function l(n){return typeof n=="number"&&!isNaN(n)}t.isNumber=l;function h(n){return n===!0||n===!1}t.isBoolean=h;function a(n){return typeof n=="undefined"}t.isUndefined=a;function o(n){return a(n)||n===null}t.isUndefinedOrNull=o;function f(n,r){if(!n)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}t.assertType=f;function S(n){if(o(n))throw new Error("Assertion Failed: argument is undefined or null");return n}t.assertIsDefined=S;function c(n){return typeof n=="function"}t.isFunction=c;function g(n,r){const s=Math.min(n.length,r.length);for(let d=0;d<s;d++)m(n[d],r[d])}t.validateConstraints=g;function m(n,r){if(P(r)){if(typeof n!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(c(r)){try{if(n instanceof r)return}catch(s){}if(!o(n)&&n.constructor===r||r.length===1&&r.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=m;function v(n){let r=[],s=Object.getPrototypeOf(n);for(;Object.prototype!==s;)r=r.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return r}t.getAllPropertyNames=v;function i(n){const r=[];for(const s of v(n))typeof n[s]=="function"&&r.push(s);return r}t.getAllMethodNames=i;function u(n,r){const s=C=>function(){const b=Array.prototype.slice.call(arguments,0);return r(C,b)};let d={};for(const C of n)d[C]=s(C);return d}t.createProxyObject=u;function _(n){return n===null?void 0:n}t.withNullAsUndefined=_;function L(n,r="Unreachable"){throw new Error(r)}t.assertNever=L}),Y(z[12],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=void 0;function E(A){return A<0?0:A>255?255:A|0}t.toUint8=E;function P(A){return A<0?0:A>4294967295?4294967295:A|0}t.toUint32=P}),Y(z[13],G([0,1,2,20]),function(I,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const A=/^\w[\w\d+.-]*$/,l=/^\//,h=/^\/\//;function a(b,N){if(!b.scheme&&N)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${b.authority}", path: "${b.path}", query: "${b.query}", fragment: "${b.fragment}"}`);if(b.scheme&&!A.test(b.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(b.path){if(b.authority){if(!l.test(b.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(h.test(b.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(b,N){return!b&&!N?"file":b}function f(b,N){switch(b){case"https":case"http":case"file":N?N[0]!==c&&(N=c+N):N=c;break}return N}const S="",c="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(N,w,y,M,U,D=!1){typeof N=="object"?(this.scheme=N.scheme||S,this.authority=N.authority||S,this.path=N.path||S,this.query=N.query||S,this.fragment=N.fragment||S):(this.scheme=o(N,D),this.authority=w||S,this.path=f(this.scheme,y||S),this.query=M||S,this.fragment=U||S,a(this,D))}static isUri(N){return N instanceof m?!0:N?typeof N.authority=="string"&&typeof N.fragment=="string"&&typeof N.path=="string"&&typeof N.query=="string"&&typeof N.scheme=="string"&&typeof N.fsPath=="string"&&typeof N.with=="function"&&typeof N.toString=="function":!1}get fsPath(){return n(this,!1)}with(N){if(!N)return this;let{scheme:w,authority:y,path:M,query:U,fragment:D}=N;return w===void 0?w=this.scheme:w===null&&(w=S),y===void 0?y=this.authority:y===null&&(y=S),M===void 0?M=this.path:M===null&&(M=S),U===void 0?U=this.query:U===null&&(U=S),D===void 0?D=this.fragment:D===null&&(D=S),w===this.scheme&&y===this.authority&&M===this.path&&U===this.query&&D===this.fragment?this:new i(w,y,M,U,D)}static parse(N,w=!1){const y=g.exec(N);return y?new i(y[2]||S,C(y[4]||S),C(y[5]||S),C(y[7]||S),C(y[9]||S),w):new i(S,S,S,S,S)}static file(N){let w=S;if(E.isWindows&&(N=N.replace(/\\/g,c)),N[0]===c&&N[1]===c){const y=N.indexOf(c,2);y===-1?(w=N.substring(2),N=c):(w=N.substring(2,y),N=N.substring(y)||c)}return new i("file",w,N,S,S)}static from(N){const w=new i(N.scheme,N.authority,N.path,N.query,N.fragment);return a(w,!0),w}static joinPath(N,...w){if(!N.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return E.isWindows&&N.scheme==="file"?y=m.file(P.win32.join(n(N,!0),...w)).path:y=P.posix.join(N.path,...w),N.with({path:y})}toString(N=!1){return r(this,N)}toJSON(){return this}static revive(N){if(N){if(N instanceof m)return N;{const w=new i(N);return w._formatted=N.external,w._fsPath=N._sep===v?N.fsPath:null,w}}else return N}}t.URI=m;const v=E.isWindows?1:void 0;class i extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(N=!1){return N?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const N={$mid:1};return this._fsPath&&(N.fsPath=this._fsPath,N._sep=v),this._formatted&&(N.external=this._formatted),this.path&&(N.path=this.path),this.scheme&&(N.scheme=this.scheme),this.authority&&(N.authority=this.authority),this.query&&(N.query=this.query),this.fragment&&(N.fragment=this.fragment),N}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(b,N){let w,y=-1;for(let M=0;M<b.length;M++){const U=b.charCodeAt(M);if(U>=97&&U<=122||U>=65&&U<=90||U>=48&&U<=57||U===45||U===46||U===95||U===126||N&&U===47)y!==-1&&(w+=encodeURIComponent(b.substring(y,M)),y=-1),w!==void 0&&(w+=b.charAt(M));else{w===void 0&&(w=b.substr(0,M));const D=u[U];D!==void 0?(y!==-1&&(w+=encodeURIComponent(b.substring(y,M)),y=-1),w+=D):y===-1&&(y=M)}}return y!==-1&&(w+=encodeURIComponent(b.substring(y))),w!==void 0?w:b}function L(b){let N;for(let w=0;w<b.length;w++){const y=b.charCodeAt(w);y===35||y===63?(N===void 0&&(N=b.substr(0,w)),N+=u[y]):N!==void 0&&(N+=b[w])}return N!==void 0?N:b}function n(b,N){let w;return b.authority&&b.path.length>1&&b.scheme==="file"?w=`//${b.authority}${b.path}`:b.path.charCodeAt(0)===47&&(b.path.charCodeAt(1)>=65&&b.path.charCodeAt(1)<=90||b.path.charCodeAt(1)>=97&&b.path.charCodeAt(1)<=122)&&b.path.charCodeAt(2)===58?N?w=b.path.substr(1):w=b.path[1].toLowerCase()+b.path.substr(2):w=b.path,E.isWindows&&(w=w.replace(/\//g,"\\")),w}t.uriToFsPath=n;function r(b,N){const w=N?L:_;let y="",{scheme:M,authority:U,path:D,query:q,fragment:V}=b;if(M&&(y+=M,y+=":"),(U||M==="file")&&(y+=c,y+=c),U){let k=U.indexOf("@");if(k!==-1){const T=U.substr(0,k);U=U.substr(k+1),k=T.indexOf(":"),k===-1?y+=w(T,!1):(y+=w(T.substr(0,k),!1),y+=":",y+=w(T.substr(k+1),!1)),y+="@"}U=U.toLowerCase(),k=U.indexOf(":"),k===-1?y+=w(U,!1):(y+=w(U.substr(0,k),!1),y+=U.substr(k))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const k=D.charCodeAt(1);k>=65&&k<=90&&(D=`/${String.fromCharCode(k+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const k=D.charCodeAt(0);k>=65&&k<=90&&(D=`${String.fromCharCode(k+32)}:${D.substr(2)}`)}y+=w(D,!0)}return q&&(y+="?",y+=w(q,!1)),V&&(y+="#",y+=N?V:_(V,!1)),y}function s(b){try{return decodeURIComponent(b)}catch(N){return b.length>3?b.substr(0,3)+s(b.substr(3)):b}}const d=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function C(b){return b.match(d)?b.replace(d,N=>s(N)):b}}),Y(z[34],G([0,1,4,7,2,11]),function(I,t,E,P,A,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const h="$initialize";let a=!1;function o(m){!A.isWeb||(a||(a=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(m.message))}t.logOnceWebWorkerWarning=o;class f{constructor(v){this._workerId=-1,this._handler=v,this._lastSentReq=0,this._pendingReplies=Object.create(null)}setWorkerId(v){this._workerId=v}sendMessage(v,i){let u=String(++this._lastSentReq);return new Promise((_,L)=>{this._pendingReplies[u]={resolve:_,reject:L},this._send({vsWorker:this._workerId,req:u,method:v,args:i})})}handleMessage(v){!v||!v.vsWorker||this._workerId!==-1&&v.vsWorker!==this._workerId||this._handleMessage(v)}_handleMessage(v){if(v.seq){let L=v;if(!this._pendingReplies[L.seq]){console.warn("Got reply to unknown seq");return}let n=this._pendingReplies[L.seq];if(delete this._pendingReplies[L.seq],L.err){let r=L.err;L.err.$isError&&(r=new Error,r.name=L.err.name,r.message=L.err.message,r.stack=L.err.stack),n.reject(r);return}n.resolve(L.res);return}let i=v,u=i.req;this._handler.handleMessage(i.method,i.args).then(L=>{this._send({vsWorker:this._workerId,seq:u,res:L,err:void 0})},L=>{L.detail instanceof Error&&(L.detail=(0,E.transformErrorForSerialization)(L.detail)),this._send({vsWorker:this._workerId,seq:u,res:void 0,err:(0,E.transformErrorForSerialization)(L)})})}_send(v){let i=[];if(v.req){const u=v;for(let _=0;_<u.args.length;_++)u.args[_]instanceof ArrayBuffer&&i.push(u.args[_])}else{const u=v;u.res instanceof ArrayBuffer&&i.push(u.res)}this._handler.sendMessage(v,i)}}class S extends P.Disposable{constructor(v,i,u){super();let _=null;this._worker=this._register(v.create("vs/base/common/worker/simpleWorker",s=>{this._protocol.handleMessage(s)},s=>{_&&_(s)})),this._protocol=new f({sendMessage:(s,d)=>{this._worker.postMessage(s,d)},handleMessage:(s,d)=>{if(typeof u[s]!="function")return Promise.reject(new Error("Missing method "+s+" on main thread host."));try{return Promise.resolve(u[s].apply(u,d))}catch(C){return Promise.reject(C)}}}),this._protocol.setWorkerId(this._worker.getId());let L=null;typeof self.require!="undefined"&&typeof self.require.getConfig=="function"?L=self.require.getConfig():typeof self.requirejs!="undefined"&&(L=self.requirejs.s.contexts._.config);const n=l.getAllMethodNames(u);this._onModuleLoaded=this._protocol.sendMessage(h,[this._worker.getId(),JSON.parse(JSON.stringify(L)),i,n]);const r=(s,d)=>this._request(s,d);this._lazyProxy=new Promise((s,d)=>{_=d,this._onModuleLoaded.then(C=>{s(l.createProxyObject(C,r))},C=>{d(C),this._onError("Worker failed to load "+i,C)})})}getProxyObject(){return this._lazyProxy}_request(v,i){return new Promise((u,_)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(v,i).then(u,_)},_)})}_onError(v,i){console.error(v),console.info(i)}}t.SimpleWorkerClient=S;class c{constructor(v,i){this._requestHandlerFactory=i,this._requestHandler=null,this._protocol=new f({sendMessage:(u,_)=>{v(u,_)},handleMessage:(u,_)=>this._handleMessage(u,_)})}onmessage(v){this._protocol.handleMessage(v)}_handleMessage(v,i){if(v===h)return this.initialize(i[0],i[1],i[2],i[3]);if(!this._requestHandler||typeof this._requestHandler[v]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+v));try{return Promise.resolve(this._requestHandler[v].apply(this._requestHandler,i))}catch(u){return Promise.reject(u)}}initialize(v,i,u,_){this._protocol.setWorkerId(v);const L=(r,s)=>this._protocol.sendMessage(r,s),n=l.createProxyObject(_,L);return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(n),Promise.resolve(l.getAllMethodNames(this._requestHandler))):(i&&(typeof i.baseUrl!="undefined"&&delete i.baseUrl,typeof i.paths!="undefined"&&typeof i.paths.vs!="undefined"&&delete i.paths.vs,typeof i.trustedTypesPolicy!==void 0&&delete i.trustedTypesPolicy,i.catchError=!0,self.require.config(i)),new Promise((r,s)=>{self.require([u],d=>{if(this._requestHandler=d.create(n),!this._requestHandler){s(new Error("No RequestHandler!"));return}r(l.getAllMethodNames(this._requestHandler))},s)}))}}t.SimpleWorkerServer=c;function g(m){return new c(m,null)}t.create=g}),Y(z[23],G([0,1,12]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class P{constructor(h){let a=(0,E.toUint8)(h);this._defaultValue=a,this._asciiMap=P._createAsciiMap(a),this._map=new Map}static _createAsciiMap(h){let a=new Uint8Array(256);for(let o=0;o<256;o++)a[o]=h;return a}set(h,a){let o=(0,E.toUint8)(a);h>=0&&h<256?this._asciiMap[h]=o:this._map.set(h,o)}get(h){return h>=0&&h<256?this._asciiMap[h]:this._map.get(h)||this._defaultValue}}t.CharacterClassifier=P;class A{constructor(){this._actual=new P(0)}add(h){this._actual.set(h,1)}has(h){return this._actual.get(h)===1}}t.CharacterSet=A}),Y(z[3],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class E{constructor(A,l){this.lineNumber=A,this.column=l}with(A=this.lineNumber,l=this.column){return A===this.lineNumber&&l===this.column?this:new E(A,l)}delta(A=0,l=0){return this.with(this.lineNumber+A,this.column+l)}equals(A){return E.equals(this,A)}static equals(A,l){return!A&&!l?!0:!!A&&!!l&&A.lineNumber===l.lineNumber&&A.column===l.column}isBefore(A){return E.isBefore(this,A)}static isBefore(A,l){return A.lineNumber<l.lineNumber?!0:l.lineNumber<A.lineNumber?!1:A.column<l.column}isBeforeOrEqual(A){return E.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,l){return A.lineNumber<l.lineNumber?!0:l.lineNumber<A.lineNumber?!1:A.column<=l.column}static compare(A,l){let h=A.lineNumber|0,a=l.lineNumber|0;if(h===a){let o=A.column|0,f=l.column|0;return o-f}return h-a}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new E(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}t.Position=E}),Y(z[6],G([0,1,3]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class P{constructor(l,h,a,o){l>a||l===a&&h>o?(this.startLineNumber=a,this.startColumn=o,this.endLineNumber=l,this.endColumn=h):(this.startLineNumber=l,this.startColumn=h,this.endLineNumber=a,this.endColumn=o)}isEmpty(){return P.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return P.containsPosition(this,l)}static containsPosition(l,h){return!(h.lineNumber<l.startLineNumber||h.lineNumber>l.endLineNumber||h.lineNumber===l.startLineNumber&&h.column<l.startColumn||h.lineNumber===l.endLineNumber&&h.column>l.endColumn)}containsRange(l){return P.containsRange(this,l)}static containsRange(l,h){return!(h.startLineNumber<l.startLineNumber||h.endLineNumber<l.startLineNumber||h.startLineNumber>l.endLineNumber||h.endLineNumber>l.endLineNumber||h.startLineNumber===l.startLineNumber&&h.startColumn<l.startColumn||h.endLineNumber===l.endLineNumber&&h.endColumn>l.endColumn)}strictContainsRange(l){return P.strictContainsRange(this,l)}static strictContainsRange(l,h){return!(h.startLineNumber<l.startLineNumber||h.endLineNumber<l.startLineNumber||h.startLineNumber>l.endLineNumber||h.endLineNumber>l.endLineNumber||h.startLineNumber===l.startLineNumber&&h.startColumn<=l.startColumn||h.endLineNumber===l.endLineNumber&&h.endColumn>=l.endColumn)}plusRange(l){return P.plusRange(this,l)}static plusRange(l,h){let a,o,f,S;return h.startLineNumber<l.startLineNumber?(a=h.startLineNumber,o=h.startColumn):h.startLineNumber===l.startLineNumber?(a=h.startLineNumber,o=Math.min(h.startColumn,l.startColumn)):(a=l.startLineNumber,o=l.startColumn),h.endLineNumber>l.endLineNumber?(f=h.endLineNumber,S=h.endColumn):h.endLineNumber===l.endLineNumber?(f=h.endLineNumber,S=Math.max(h.endColumn,l.endColumn)):(f=l.endLineNumber,S=l.endColumn),new P(a,o,f,S)}intersectRanges(l){return P.intersectRanges(this,l)}static intersectRanges(l,h){let a=l.startLineNumber,o=l.startColumn,f=l.endLineNumber,S=l.endColumn,c=h.startLineNumber,g=h.startColumn,m=h.endLineNumber,v=h.endColumn;return a<c?(a=c,o=g):a===c&&(o=Math.max(o,g)),f>m?(f=m,S=v):f===m&&(S=Math.min(S,v)),a>f||a===f&&o>S?null:new P(a,o,f,S)}equalsRange(l){return P.equalsRange(this,l)}static equalsRange(l,h){return!!l&&!!h&&l.startLineNumber===h.startLineNumber&&l.startColumn===h.startColumn&&l.endLineNumber===h.endLineNumber&&l.endColumn===h.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(l){return new E.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(l){return new E.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,h){return new P(this.startLineNumber,this.startColumn,l,h)}setStartPosition(l,h){return new P(l,h,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(l){return new P(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}static fromPositions(l,h=l){return new P(l.lineNumber,l.column,h.lineNumber,h.column)}static lift(l){return l?new P(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,h){return!(l.endLineNumber<h.startLineNumber||l.endLineNumber===h.startLineNumber&&l.endColumn<h.startColumn||h.endLineNumber<l.startLineNumber||h.endLineNumber===l.startLineNumber&&h.endColumn<l.startColumn)}static areIntersecting(l,h){return!(l.endLineNumber<h.startLineNumber||l.endLineNumber===h.startLineNumber&&l.endColumn<=h.startColumn||h.endLineNumber<l.startLineNumber||h.endLineNumber===l.startLineNumber&&h.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,h){if(l&&h){const f=l.startLineNumber|0,S=h.startLineNumber|0;if(f===S){const c=l.startColumn|0,g=h.startColumn|0;if(c===g){const m=l.endLineNumber|0,v=h.endLineNumber|0;if(m===v){const i=l.endColumn|0,u=h.endColumn|0;return i-u}return m-v}return c-g}return f-S}return(l?1:0)-(h?1:0)}static compareRangesUsingEnds(l,h){return l.endLineNumber===h.endLineNumber?l.endColumn===h.endColumn?l.startLineNumber===h.startLineNumber?l.startColumn-h.startColumn:l.startLineNumber-h.startLineNumber:l.endColumn-h.endColumn:l.endLineNumber-h.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}}t.Range=P}),Y(z[24],G([0,1,3,6]),function(I,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=void 0;class A extends P.Range{constructor(h,a,o,f){super(h,a,o,f);this.selectionStartLineNumber=h,this.selectionStartColumn=a,this.positionLineNumber=o,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return A.selectionsEqual(this,h)}static selectionsEqual(h,a){return h.selectionStartLineNumber===a.selectionStartLineNumber&&h.selectionStartColumn===a.selectionStartColumn&&h.positionLineNumber===a.positionLineNumber&&h.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,a){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,h,a):new A(h,a,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(h,a){return this.getDirection()===0?new A(h,a,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,h,a)}static fromPositions(h,a=h){return new A(h.lineNumber,h.column,a.lineNumber,a.column)}static liftSelection(h){return new A(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,a){if(h&&!a||!h&&a)return!1;if(!h&&!a)return!0;if(h.length!==a.length)return!1;for(let o=0,f=h.length;o<f;o++)if(!this.selectionsEqual(h[o],a[o]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,a,o,f,S){return S===0?new A(h,a,o,f):new A(o,f,h,a)}}t.Selection=A}),Y(z[25],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;class E{constructor(h,a,o){this._tokenBrand=void 0,this.offset=h|0,this.type=a,this.language=o}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=E;class P{constructor(h,a){this._tokenizationResultBrand=void 0,this.tokens=h,this.endState=a}}t.TokenizationResult=P;class A{constructor(h,a){this._tokenizationResult2Brand=void 0,this.tokens=h,this.endState=a}}t.TokenizationResult2=A}),Y(z[26],G([0,1,10,5]),function(I,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const A=3;function l(i,u,_,L){return new E.LcsDiff(i,u,_).ComputeDiff(L)}class h{constructor(u){const _=[],L=[];for(let n=0,r=u.length;n<r;n++)_[n]=g(u[n],1),L[n]=m(u[n],1);this.lines=u,this._startColumns=_,this._endColumns=L}getElements(){const u=[];for(let _=0,L=this.lines.length;_<L;_++)u[_]=this.lines[_].substring(this._startColumns[_]-1,this._endColumns[_]-1);return u}getStrictElement(u){return this.lines[u]}getStartLineNumber(u){return u+1}getEndLineNumber(u){return u+1}createCharSequence(u,_,L){const n=[],r=[],s=[];let d=0;for(let C=_;C<=L;C++){const b=this.lines[C],N=u?this._startColumns[C]:1,w=u?this._endColumns[C]:b.length+1;for(let y=N;y<w;y++)n[d]=b.charCodeAt(y-1),r[d]=C+1,s[d]=y,d++}return new a(n,r,s)}}class a{constructor(u,_,L){this._charCodes=u,this._lineNumbers=_,this._columns=L}getElements(){return this._charCodes}getStartLineNumber(u){return this._lineNumbers[u]}getStartColumn(u){return this._columns[u]}getEndLineNumber(u){return this._lineNumbers[u]}getEndColumn(u){return this._columns[u]+1}}class o{constructor(u,_,L,n,r,s,d,C){this.originalStartLineNumber=u,this.originalStartColumn=_,this.originalEndLineNumber=L,this.originalEndColumn=n,this.modifiedStartLineNumber=r,this.modifiedStartColumn=s,this.modifiedEndLineNumber=d,this.modifiedEndColumn=C}static createFromDiffChange(u,_,L){let n,r,s,d,C,b,N,w;return u.originalLength===0?(n=0,r=0,s=0,d=0):(n=_.getStartLineNumber(u.originalStart),r=_.getStartColumn(u.originalStart),s=_.getEndLineNumber(u.originalStart+u.originalLength-1),d=_.getEndColumn(u.originalStart+u.originalLength-1)),u.modifiedLength===0?(C=0,b=0,N=0,w=0):(C=L.getStartLineNumber(u.modifiedStart),b=L.getStartColumn(u.modifiedStart),N=L.getEndLineNumber(u.modifiedStart+u.modifiedLength-1),w=L.getEndColumn(u.modifiedStart+u.modifiedLength-1)),new o(n,r,s,d,C,b,N,w)}}function f(i){if(i.length<=1)return i;const u=[i[0]];let _=u[0];for(let L=1,n=i.length;L<n;L++){const r=i[L],s=r.originalStart-(_.originalStart+_.originalLength),d=r.modifiedStart-(_.modifiedStart+_.modifiedLength);Math.min(s,d)<A?(_.originalLength=r.originalStart+r.originalLength-_.originalStart,_.modifiedLength=r.modifiedStart+r.modifiedLength-_.modifiedStart):(u.push(r),_=r)}return u}class S{constructor(u,_,L,n,r){this.originalStartLineNumber=u,this.originalEndLineNumber=_,this.modifiedStartLineNumber=L,this.modifiedEndLineNumber=n,this.charChanges=r}static createFromDiffResult(u,_,L,n,r,s,d){let C,b,N,w,y;if(_.originalLength===0?(C=L.getStartLineNumber(_.originalStart)-1,b=0):(C=L.getStartLineNumber(_.originalStart),b=L.getEndLineNumber(_.originalStart+_.originalLength-1)),_.modifiedLength===0?(N=n.getStartLineNumber(_.modifiedStart)-1,w=0):(N=n.getStartLineNumber(_.modifiedStart),w=n.getEndLineNumber(_.modifiedStart+_.modifiedLength-1)),s&&_.originalLength>0&&_.originalLength<20&&_.modifiedLength>0&&_.modifiedLength<20&&r()){const M=L.createCharSequence(u,_.originalStart,_.originalStart+_.originalLength-1),U=n.createCharSequence(u,_.modifiedStart,_.modifiedStart+_.modifiedLength-1);let D=l(M,U,r,!0).changes;d&&(D=f(D)),y=[];for(let q=0,V=D.length;q<V;q++)y.push(o.createFromDiffChange(D[q],M,U))}return new S(C,b,N,w,y)}}class c{constructor(u,_,L){this.shouldComputeCharChanges=L.shouldComputeCharChanges,this.shouldPostProcessCharChanges=L.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=L.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=L.shouldMakePrettyDiff,this.originalLines=u,this.modifiedLines=_,this.original=new h(u),this.modified=new h(_),this.continueLineDiff=v(L.maxComputationTime),this.continueCharDiff=v(L.maxComputationTime===0?0:Math.min(L.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const u=l(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),_=u.changes,L=u.quitEarly;if(this.shouldIgnoreTrimWhitespace){const d=[];for(let C=0,b=_.length;C<b;C++)d.push(S.createFromDiffResult(this.shouldIgnoreTrimWhitespace,_[C],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:L,changes:d}}const n=[];let r=0,s=0;for(let d=-1,C=_.length;d<C;d++){const b=d+1<C?_[d+1]:null,N=b?b.originalStart:this.originalLines.length,w=b?b.modifiedStart:this.modifiedLines.length;for(;r<N&&s<w;){const y=this.originalLines[r],M=this.modifiedLines[s];if(y!==M){{let U=g(y,1),D=g(M,1);for(;U>1&&D>1;){const q=y.charCodeAt(U-2),V=M.charCodeAt(D-2);if(q!==V)break;U--,D--}(U>1||D>1)&&this._pushTrimWhitespaceCharChange(n,r+1,1,U,s+1,1,D)}{let U=m(y,1),D=m(M,1);const q=y.length+1,V=M.length+1;for(;U<q&&D<V;){const k=y.charCodeAt(U-1),T=y.charCodeAt(D-1);if(k!==T)break;U++,D++}(U<q||D<V)&&this._pushTrimWhitespaceCharChange(n,r+1,U,q,s+1,D,V)}}r++,s++}b&&(n.push(S.createFromDiffResult(this.shouldIgnoreTrimWhitespace,b,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),r+=b.originalLength,s+=b.modifiedLength)}return{quitEarly:L,changes:n}}_pushTrimWhitespaceCharChange(u,_,L,n,r,s,d){if(this._mergeTrimWhitespaceCharChange(u,_,L,n,r,s,d))return;let C;this.shouldComputeCharChanges&&(C=[new o(_,L,_,n,r,s,r,d)]),u.push(new S(_,_,r,r,C))}_mergeTrimWhitespaceCharChange(u,_,L,n,r,s,d){const C=u.length;if(C===0)return!1;const b=u[C-1];return b.originalEndLineNumber===0||b.modifiedEndLineNumber===0?!1:b.originalEndLineNumber+1===_&&b.modifiedEndLineNumber+1===r?(b.originalEndLineNumber=_,b.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&b.charChanges&&b.charChanges.push(new o(_,L,_,n,r,s,r,d)),!0):!1}}t.DiffComputer=c;function g(i,u){const _=P.firstNonWhitespaceIndex(i);return _===-1?u:_+1}function m(i,u){const _=P.lastNonWhitespaceIndex(i);return _===-1?u:_+2}function v(i){if(i===0)return()=>!0;const u=Date.now();return()=>Date.now()-u<i}}),Y(z[27],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(a=""){let o="(-?\\d*\\.\\d\\w*)|([^";for(const f of t.USUAL_WORD_SEPARATORS)a.indexOf(f)>=0||(o+="\\"+f);return o+="\\s]+)",new RegExp(o,"g")}t.DEFAULT_WORD_REGEXP=E();function P(a){let o=t.DEFAULT_WORD_REGEXP;if(a&&a instanceof RegExp)if(a.global)o=a;else{let f="g";a.ignoreCase&&(f+="i"),a.multiline&&(f+="m"),a.unicode&&(f+="u"),o=new RegExp(a.source,f)}return o.lastIndex=0,o}t.ensureValidWordDefinition=P;const A={maxLen:1e3,windowSize:15,timeBudget:150};function l(a,o,f,S,c=A){if(f.length>c.maxLen){let u=a-c.maxLen/2;return u<0?u=0:S+=u,f=f.substring(u,a+c.maxLen/2),l(a,o,f,S,c)}const g=Date.now(),m=a-1-S;let v=-1,i=null;for(let u=1;!(Date.now()-g>=c.timeBudget);u++){const _=m-c.windowSize*u;o.lastIndex=Math.max(0,_);const L=h(o,f,m,v);if(!L&&i||(i=L,_<=0))break;v=_}if(i){let u={word:i[0],startColumn:S+1+i.index,endColumn:S+1+i.index+i[0].length};return o.lastIndex=0,u}return null}t.getWordAtText=l;function h(a,o,f,S){let c;for(;c=a.exec(o);){const g=c.index||0;if(g<=f&&a.lastIndex>=f)return c;if(S>0&&g>S)return null}return null}}),Y(z[28],G([0,1,23]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=void 0;class P{constructor(g,m,v){const i=new Uint8Array(g*m);for(let u=0,_=g*m;u<_;u++)i[u]=v;this._data=i,this.rows=g,this.cols=m}get(g,m){return this._data[g*this.cols+m]}set(g,m,v){this._data[g*this.cols+m]=v}}t.Uint8Matrix=P;class A{constructor(g){let m=0,v=0;for(let u=0,_=g.length;u<_;u++){let[L,n,r]=g[u];n>m&&(m=n),L>v&&(v=L),r>v&&(v=r)}m++,v++;let i=new P(v,m,0);for(let u=0,_=g.length;u<_;u++){let[L,n,r]=g[u];i.set(L,n,r)}this._states=i,this._maxCharCode=m}nextState(g,m){return m<0||m>=this._maxCharCode?0:this._states.get(g,m)}}t.StateMachine=A;let l=null;function h(){return l===null&&(l=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),l}let a=null;function o(){if(a===null){a=new E.CharacterClassifier(0);const c=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<c.length;m++)a.set(c.charCodeAt(m),1);const g=".,;";for(let m=0;m<g.length;m++)a.set(g.charCodeAt(m),2)}return a}class f{static _createLink(g,m,v,i,u){let _=u-1;do{const L=m.charCodeAt(_);if(g.get(L)!==2)break;_--}while(_>i);if(i>0){const L=m.charCodeAt(i-1),n=m.charCodeAt(_);(L===40&&n===41||L===91&&n===93||L===123&&n===125)&&_--}return{range:{startLineNumber:v,startColumn:i+1,endLineNumber:v,endColumn:_+2},url:m.substring(i,_+1)}}static computeLinks(g,m=h()){const v=o();let i=[];for(let u=1,_=g.getLineCount();u<=_;u++){const L=g.getLineContent(u),n=L.length;let r=0,s=0,d=0,C=1,b=!1,N=!1,w=!1,y=!1;for(;r<n;){let M=!1;const U=L.charCodeAt(r);if(C===13){let D;switch(U){case 40:b=!0,D=0;break;case 41:D=b?0:1;break;case 91:w=!0,N=!0,D=0;break;case 93:w=!1,D=N?0:1;break;case 123:y=!0,D=0;break;case 125:D=y?0:1;break;case 39:D=d===34||d===96?0:1;break;case 34:D=d===39||d===96?0:1;break;case 96:D=d===39||d===34?0:1;break;case 42:D=d===42?1:0;break;case 124:D=d===124?1:0;break;case 32:D=w?0:1;break;default:D=v.get(U)}D===1&&(i.push(f._createLink(v,L,u,s,r)),M=!0)}else if(C===12){let D;U===91?(N=!0,D=0):D=v.get(U),D===1?M=!0:C=13}else C=m.nextState(C,U),C===0&&(M=!0);M&&(C=1,b=!1,N=!1,y=!1,s=r+1,d=U),r++}C===13&&i.push(f._createLink(v,L,u,s,n))}return i}}t.LinkComputer=f;function S(c){return!c||typeof c.getLineCount!="function"||typeof c.getLineContent!="function"?[]:f.computeLinks(c)}t.computeLinks=S}),Y(z[29],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class E{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(A,l,h,a,o){if(A&&l){let f=this.doNavigateValueSet(l,o);if(f)return{range:A,value:f}}if(h&&a){let f=this.doNavigateValueSet(a,o);if(f)return{range:h,value:f}}return null}doNavigateValueSet(A,l){let h=this.numberReplace(A,l);return h!==null?h:this.textReplace(A,l)}numberReplace(A,l){let h=Math.pow(10,A.length-(A.lastIndexOf(".")+1)),a=Number(A),o=parseFloat(A);return!isNaN(a)&&!isNaN(o)&&a===o?a===0&&!l?null:(a=Math.floor(a*h),a+=l?h:-h,String(a/h)):null}textReplace(A,l){return this.valueSetsReplace(this._defaultValueSet,A,l)}valueSetsReplace(A,l,h){let a=null;for(let o=0,f=A.length;a===null&&o<f;o++)a=this.valueSetReplace(A[o],l,h);return a}valueSetReplace(A,l,h){let a=A.indexOf(l);return a>=0?(a+=h?1:-1,a<0?a=A.length-1:a%=A.length,A[a]):null}}t.BasicInplaceReplace=E,E.INSTANCE=new E}),Y(z[30],G([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var E;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(E=t.AccessibilitySupport||(t.AccessibilitySupport={}));var P;(function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(P=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var A;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(A=t.CompletionItemKind||(t.CompletionItemKind={}));var l;(function(e){e[e.Deprecated=1]="Deprecated"})(l=t.CompletionItemTag||(t.CompletionItemTag={}));var h;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var a;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(a=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var o;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(o=t.CursorChangeReason||(t.CursorChangeReason={}));var f;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(f=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var S;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(S=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var c;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(c=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var g;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingDelete=6]="autoClosingDelete",e[e.autoClosingOvertype=7]="autoClosingOvertype",e[e.autoClosingQuotes=8]="autoClosingQuotes",e[e.autoIndent=9]="autoIndent",e[e.automaticLayout=10]="automaticLayout",e[e.autoSurround=11]="autoSurround",e[e.codeLens=12]="codeLens",e[e.codeLensFontFamily=13]="codeLensFontFamily",e[e.codeLensFontSize=14]="codeLensFontSize",e[e.colorDecorators=15]="colorDecorators",e[e.columnSelection=16]="columnSelection",e[e.comments=17]="comments",e[e.contextmenu=18]="contextmenu",e[e.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",e[e.cursorBlinking=20]="cursorBlinking",e[e.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",e[e.cursorStyle=22]="cursorStyle",e[e.cursorSurroundingLines=23]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",e[e.cursorWidth=25]="cursorWidth",e[e.disableLayerHinting=26]="disableLayerHinting",e[e.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",e[e.domReadOnly=28]="domReadOnly",e[e.dragAndDrop=29]="dragAndDrop",e[e.emptySelectionClipboard=30]="emptySelectionClipboard",e[e.extraEditorClassName=31]="extraEditorClassName",e[e.fastScrollSensitivity=32]="fastScrollSensitivity",e[e.find=33]="find",e[e.fixedOverflowWidgets=34]="fixedOverflowWidgets",e[e.folding=35]="folding",e[e.foldingStrategy=36]="foldingStrategy",e[e.foldingHighlight=37]="foldingHighlight",e[e.foldingImportsByDefault=38]="foldingImportsByDefault",e[e.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=40]="fontFamily",e[e.fontInfo=41]="fontInfo",e[e.fontLigatures=42]="fontLigatures",e[e.fontSize=43]="fontSize",e[e.fontWeight=44]="fontWeight",e[e.formatOnPaste=45]="formatOnPaste",e[e.formatOnType=46]="formatOnType",e[e.glyphMargin=47]="glyphMargin",e[e.gotoLocation=48]="gotoLocation",e[e.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",e[e.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",e[e.hover=51]="hover",e[e.inDiffEditor=52]="inDiffEditor",e[e.inlineSuggest=53]="inlineSuggest",e[e.letterSpacing=54]="letterSpacing",e[e.lightbulb=55]="lightbulb",e[e.lineDecorationsWidth=56]="lineDecorationsWidth",e[e.lineHeight=57]="lineHeight",e[e.lineNumbers=58]="lineNumbers",e[e.lineNumbersMinChars=59]="lineNumbersMinChars",e[e.linkedEditing=60]="linkedEditing",e[e.links=61]="links",e[e.matchBrackets=62]="matchBrackets",e[e.minimap=63]="minimap",e[e.mouseStyle=64]="mouseStyle",e[e.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=66]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",e[e.multiCursorModifier=68]="multiCursorModifier",e[e.multiCursorPaste=69]="multiCursorPaste",e[e.occurrencesHighlight=70]="occurrencesHighlight",e[e.overviewRulerBorder=71]="overviewRulerBorder",e[e.overviewRulerLanes=72]="overviewRulerLanes",e[e.padding=73]="padding",e[e.parameterHints=74]="parameterHints",e[e.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",e[e.quickSuggestions=77]="quickSuggestions",e[e.quickSuggestionsDelay=78]="quickSuggestionsDelay",e[e.readOnly=79]="readOnly",e[e.renameOnType=80]="renameOnType",e[e.renderControlCharacters=81]="renderControlCharacters",e[e.renderIndentGuides=82]="renderIndentGuides",e[e.renderFinalNewline=83]="renderFinalNewline",e[e.renderLineHighlight=84]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=86]="renderValidationDecorations",e[e.renderWhitespace=87]="renderWhitespace",e[e.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",e[e.roundedSelection=89]="roundedSelection",e[e.rulers=90]="rulers",e[e.scrollbar=91]="scrollbar",e[e.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=93]="scrollBeyondLastLine",e[e.scrollPredominantAxis=94]="scrollPredominantAxis",e[e.selectionClipboard=95]="selectionClipboard",e[e.selectionHighlight=96]="selectionHighlight",e[e.selectOnLineNumbers=97]="selectOnLineNumbers",e[e.showFoldingControls=98]="showFoldingControls",e[e.showUnused=99]="showUnused",e[e.snippetSuggestions=100]="snippetSuggestions",e[e.smartSelect=101]="smartSelect",e[e.smoothScrolling=102]="smoothScrolling",e[e.stickyTabStops=103]="stickyTabStops",e[e.stopRenderingLineAfter=104]="stopRenderingLineAfter",e[e.suggest=105]="suggest",e[e.suggestFontSize=106]="suggestFontSize",e[e.suggestLineHeight=107]="suggestLineHeight",e[e.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",e[e.suggestSelection=109]="suggestSelection",e[e.tabCompletion=110]="tabCompletion",e[e.tabIndex=111]="tabIndex",e[e.unusualLineTerminators=112]="unusualLineTerminators",e[e.useShadowDOM=113]="useShadowDOM",e[e.useTabStops=114]="useTabStops",e[e.wordSeparators=115]="wordSeparators",e[e.wordWrap=116]="wordWrap",e[e.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=119]="wordWrapColumn",e[e.wordWrapOverride1=120]="wordWrapOverride1",e[e.wordWrapOverride2=121]="wordWrapOverride2",e[e.wrappingIndent=122]="wrappingIndent",e[e.wrappingStrategy=123]="wrappingStrategy",e[e.showDeprecated=124]="showDeprecated",e[e.inlayHints=125]="inlayHints",e[e.editorClassName=126]="editorClassName",e[e.pixelRatio=127]="pixelRatio",e[e.tabFocusMode=128]="tabFocusMode",e[e.layoutInfo=129]="layoutInfo",e[e.wrappingInfo=130]="wrappingInfo"})(g=t.EditorOption||(t.EditorOption={}));var m;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(m=t.EndOfLinePreference||(t.EndOfLinePreference={}));var v;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(v=t.EndOfLineSequence||(t.EndOfLineSequence={}));var i;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(i=t.IndentAction||(t.IndentAction={}));var u;(function(e){e[e.Other=0]="Other",e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"})(u=t.InlayHintKind||(t.InlayHintKind={}));var _;(function(e){e[e.Automatic=0]="Automatic",e[e.Explicit=1]="Explicit"})(_=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var L;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"})(L=t.KeyCode||(t.KeyCode={}));var n;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(n=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var s;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(s=t.MinimapPosition||(t.MinimapPosition={}));var d;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d=t.MouseTargetType||(t.MouseTargetType={}));var C;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(C=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var b;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(b=t.OverviewRulerLane||(t.OverviewRulerLane={}));var N;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(N=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var w;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(w=t.RenderMinimap||(t.RenderMinimap={}));var y;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(y=t.ScrollType||(t.ScrollType={}));var M;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(M=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var U;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(U=t.SelectionDirection||(t.SelectionDirection={}));var D;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(D=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var q;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(q=t.SymbolKind||(t.SymbolKind={}));var V;(function(e){e[e.Deprecated=1]="Deprecated"})(V=t.SymbolTag||(t.SymbolTag={}));var k;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})(k=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var T;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})(T=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var O;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(O=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var H;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})(H=t.WrappingIndent||(t.WrappingIndent={}))}),Y(z[31],G([0,1,21,9,17,13,3,6,24,25,30]),function(I,t,E,P,A,l,h,a,o,f,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class c{static chord(v,i){return(0,A.KeyChord)(v,i)}}t.KeyMod=c,c.CtrlCmd=2048,c.Shift=1024,c.Alt=512,c.WinCtrl=256;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:P.Emitter,KeyCode:S.KeyCode,KeyMod:c,Position:h.Position,Range:a.Range,Selection:o.Selection,SelectionDirection:S.SelectionDirection,MarkerSeverity:S.MarkerSeverity,MarkerTag:S.MarkerTag,Uri:l.URI,Token:f.Token}}t.createMonacoBaseAPI=g}),Y(z[32],G([0,1,12]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;class P{constructor(h,a){this._prefixSumIndexOfResultBrand=void 0,this.index=h,this.remainder=a}}t.PrefixSumIndexOfResult=P;class A{constructor(h){this.values=h,this.prefixSum=new Uint32Array(h.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(h,a){h=(0,E.toUint32)(h);const o=this.values,f=this.prefixSum,S=a.length;return S===0?!1:(this.values=new Uint32Array(o.length+S),this.values.set(o.subarray(0,h),0),this.values.set(o.subarray(h),h+S),this.values.set(a,h),h-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=h-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(f.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(h,a){return h=(0,E.toUint32)(h),a=(0,E.toUint32)(a),this.values[h]===a?!1:(this.values[h]=a,h-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=h-1),!0)}removeValues(h,a){h=(0,E.toUint32)(h),a=(0,E.toUint32)(a);const o=this.values,f=this.prefixSum;if(h>=o.length)return!1;let S=o.length-h;return a>=S&&(a=S),a===0?!1:(this.values=new Uint32Array(o.length-a),this.values.set(o.subarray(0,h),0),this.values.set(o.subarray(h+a),h),this.prefixSum=new Uint32Array(this.values.length),h-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=h-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(f.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(h){return h<0?0:(h=(0,E.toUint32)(h),this._getPrefixSum(h))}_getPrefixSum(h){if(h<=this.prefixSumValidIndex[0])return this.prefixSum[h];let a=this.prefixSumValidIndex[0]+1;a===0&&(this.prefixSum[0]=this.values[0],a++),h>=this.values.length&&(h=this.values.length-1);for(let o=a;o<=h;o++)this.prefixSum[o]=this.prefixSum[o-1]+this.values[o];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],h),this.prefixSum[h]}getIndexOf(h){h=Math.floor(h),this.getTotalSum();let a=0,o=this.values.length-1,f=0,S=0,c=0;for(;a<=o;)if(f=a+(o-a)/2|0,S=this.prefixSum[f],c=S-this.values[f],h<c)o=f-1;else if(h>=S)a=f+1;else break;return new P(f,h-c)}}t.PrefixSumComputer=A}),Y(z[33],G([0,1,5,3,32]),function(I,t,E,P,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class l{constructor(a,o,f,S){this._uri=a,this._lines=o,this._eol=f,this._versionId=S,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(a){a.eol&&a.eol!==this._eol&&(this._eol=a.eol,this._lineStarts=null);const o=a.changes;for(const f of o)this._acceptDeleteRange(f.range),this._acceptInsertText(new P.Position(f.range.startLineNumber,f.range.startColumn),f.text);this._versionId=a.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const a=this._eol.length,o=this._lines.length,f=new Uint32Array(o);for(let S=0;S<o;S++)f[S]=this._lines[S].length+a;this._lineStarts=new A.PrefixSumComputer(f)}}_setLineText(a,o){this._lines[a]=o,this._lineStarts&&this._lineStarts.changeValue(a,this._lines[a].length+this._eol.length)}_acceptDeleteRange(a){if(a.startLineNumber===a.endLineNumber){if(a.startColumn===a.endColumn)return;this._setLineText(a.startLineNumber-1,this._lines[a.startLineNumber-1].substring(0,a.startColumn-1)+this._lines[a.startLineNumber-1].substring(a.endColumn-1));return}this._setLineText(a.startLineNumber-1,this._lines[a.startLineNumber-1].substring(0,a.startColumn-1)+this._lines[a.endLineNumber-1].substring(a.endColumn-1)),this._lines.splice(a.startLineNumber,a.endLineNumber-a.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(a.startLineNumber,a.endLineNumber-a.startLineNumber)}_acceptInsertText(a,o){if(o.length===0)return;let f=(0,E.splitLines)(o);if(f.length===1){this._setLineText(a.lineNumber-1,this._lines[a.lineNumber-1].substring(0,a.column-1)+f[0]+this._lines[a.lineNumber-1].substring(a.column-1));return}f[f.length-1]+=this._lines[a.lineNumber-1].substring(a.column-1),this._setLineText(a.lineNumber-1,this._lines[a.lineNumber-1].substring(0,a.column-1)+f[0]);let S=new Uint32Array(f.length-1);for(let c=1;c<f.length;c++)this._lines.splice(a.lineNumber+c-1,0,f[c]),S[c-1]=f[c].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(a.lineNumber,S)}}t.MirrorTextModel=l});var ne=this&&this.__awaiter||function(I,t,E,P){function A(l){return l instanceof E?l:new E(function(h){h(l)})}return new(E||(E=Promise))(function(l,h){function a(S){try{f(P.next(S))}catch(c){h(c)}}function o(S){try{f(P.throw(S))}catch(c){h(c)}}function f(S){S.done?l(S.value):A(S.value).then(a,o)}f((P=P.apply(I,t||[])).next())})};Y(z[35],G([0,1,10,2,13,3,6,26,33,27,28,29,31,11,8]),function(I,t,E,P,A,l,h,a,o,f,S,c,g,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class i extends o.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(n){return this._lines[n-1]}getWordAtPosition(n,r){let s=(0,f.getWordAtText)(n.column,(0,f.ensureValidWordDefinition)(r),this._lines[n.lineNumber-1],0);return s?new h.Range(n.lineNumber,s.startColumn,n.lineNumber,s.endColumn):null}words(n){const r=this._lines,s=this._wordenize.bind(this);let d=0,C="",b=0,N=[];return{*[Symbol.iterator](){for(;;)if(b<N.length){const w=C.substring(N[b].start,N[b].end);b+=1,yield w}else if(d<r.length)C=r[d],N=s(C,n),b=0,d+=1;else break}}}getLineWords(n,r){let s=this._lines[n-1],d=this._wordenize(s,r),C=[];for(const b of d)C.push({word:s.substring(b.start,b.end),startColumn:b.start+1,endColumn:b.end+1});return C}_wordenize(n,r){const s=[];let d;for(r.lastIndex=0;(d=r.exec(n))&&d[0].length!==0;)s.push({start:d.index,end:d.index+d[0].length});return s}getValueInRange(n){if(n=this._validateRange(n),n.startLineNumber===n.endLineNumber)return this._lines[n.startLineNumber-1].substring(n.startColumn-1,n.endColumn-1);let r=this._eol,s=n.startLineNumber-1,d=n.endLineNumber-1,C=[];C.push(this._lines[s].substring(n.startColumn-1));for(let b=s+1;b<d;b++)C.push(this._lines[b]);return C.push(this._lines[d].substring(0,n.endColumn-1)),C.join(r)}offsetAt(n){return n=this._validatePosition(n),this._ensureLineStarts(),this._lineStarts.getPrefixSum(n.lineNumber-2)+(n.column-1)}positionAt(n){n=Math.floor(n),n=Math.max(0,n),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(n),s=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,s)}}_validateRange(n){const r=this._validatePosition({lineNumber:n.startLineNumber,column:n.startColumn}),s=this._validatePosition({lineNumber:n.endLineNumber,column:n.endColumn});return r.lineNumber!==n.startLineNumber||r.column!==n.startColumn||s.lineNumber!==n.endLineNumber||s.column!==n.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:s.lineNumber,endColumn:s.column}:n}_validatePosition(n){if(!l.Position.isIPosition(n))throw new Error("bad position");let{lineNumber:r,column:s}=n,d=!1;if(r<1)r=1,s=1,d=!0;else if(r>this._lines.length)r=this._lines.length,s=this._lines[r-1].length+1,d=!0;else{let C=this._lines[r-1].length+1;s<1?(s=1,d=!0):s>C&&(s=C,d=!0)}return d?{lineNumber:r,column:s}:n}}class u{constructor(n,r){this._host=n,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(n){return this._models[n]}_getModels(){let n=[];return Object.keys(this._models).forEach(r=>n.push(this._models[r])),n}acceptNewModel(n){this._models[n.url]=new i(A.URI.parse(n.url),n.lines,n.EOL,n.versionId)}acceptModelChanged(n,r){if(!this._models[n])return;this._models[n].onEvents(r)}acceptRemovedModel(n){!this._models[n]||delete this._models[n]}computeDiff(n,r,s,d){return ne(this,void 0,void 0,function*(){const C=this._getModel(n),b=this._getModel(r);if(!C||!b)return null;const N=C.getLinesContent(),w=b.getLinesContent(),M=new a.DiffComputer(N,w,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:d}).computeDiff(),U=M.changes.length>0?!1:this._modelsAreIdentical(C,b);return{quitEarly:M.quitEarly,identical:U,changes:M.changes}})}_modelsAreIdentical(n,r){const s=n.getLineCount(),d=r.getLineCount();if(s!==d)return!1;for(let C=1;C<=s;C++){const b=n.getLineContent(C),N=r.getLineContent(C);if(b!==N)return!1}return!0}computeMoreMinimalEdits(n,r){return ne(this,void 0,void 0,function*(){const s=this._getModel(n);if(!s)return r;const d=[];let C;r=r.slice(0).sort((b,N)=>{if(b.range&&N.range)return h.Range.compareRangesUsingStarts(b.range,N.range);let w=b.range?0:1,y=N.range?0:1;return w-y});for(let{range:b,text:N,eol:w}of r){if(typeof w=="number"&&(C=w),h.Range.isEmpty(b)&&!N)continue;const y=s.getValueInRange(b);if(N=N.replace(/\r\n|\n|\r/g,s.eol),y===N)continue;if(Math.max(N.length,y.length)>u._diffLimit){d.push({range:b,text:N});continue}const M=(0,E.stringDiff)(y,N,!1),U=s.offsetAt(h.Range.lift(b).getStartPosition());for(const D of M){const q=s.positionAt(U+D.originalStart),V=s.positionAt(U+D.originalStart+D.originalLength),k={text:N.substr(D.modifiedStart,D.modifiedLength),range:{startLineNumber:q.lineNumber,startColumn:q.column,endLineNumber:V.lineNumber,endColumn:V.column}};s.getValueInRange(k.range)!==k.text&&d.push(k)}}return typeof C=="number"&&d.push({eol:C,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),d})}computeLinks(n){return ne(this,void 0,void 0,function*(){let r=this._getModel(n);return r?(0,S.computeLinks)(r):null})}textualSuggest(n,r,s,d){return ne(this,void 0,void 0,function*(){const C=new v.StopWatch(!0),b=new RegExp(s,d),N=new Set;e:for(let w of n){const y=this._getModel(w);if(!!y){for(let M of y.words(b))if(!(M===r||!isNaN(Number(M)))&&(N.add(M),N.size>u._suggestionsLimit))break e}}return{words:Array.from(N),duration:C.elapsed()}})}computeWordRanges(n,r,s,d){return ne(this,void 0,void 0,function*(){let C=this._getModel(n);if(!C)return Object.create(null);const b=new RegExp(s,d),N=Object.create(null);for(let w=r.startLineNumber;w<r.endLineNumber;w++){let y=C.getLineWords(w,b);for(const M of y){if(!isNaN(Number(M.word)))continue;let U=N[M.word];U||(U=[],N[M.word]=U),U.push({startLineNumber:w,startColumn:M.startColumn,endLineNumber:w,endColumn:M.endColumn})}}return N})}navigateValueSet(n,r,s,d,C){return ne(this,void 0,void 0,function*(){let b=this._getModel(n);if(!b)return null;let N=new RegExp(d,C);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let w=b.getValueInRange(r),y=b.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},N);if(!y)return null;let M=b.getValueInRange(y);return c.BasicInplaceReplace.INSTANCE.navigateValueSet(r,w,y,M,s)})}loadForeignModule(n,r,s){const d=(N,w)=>this._host.fhr(N,w);let b={host:m.createProxyObject(s,d),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(b,r),Promise.resolve(m.getAllMethodNames(this._foreignModule))):new Promise((N,w)=>{I([n],y=>{this._foreignModule=y.create(b,r),N(m.getAllMethodNames(this._foreignModule))},w)})}fmr(n,r){if(!this._foreignModule||typeof this._foreignModule[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this._foreignModule[n].apply(this._foreignModule,r))}catch(s){return Promise.reject(s)}}}t.EditorSimpleWorker=u,u._diffLimit=1e5,u._suggestionsLimit=1e4;function _(L){return new u(L,null)}t.create=_,typeof importScripts=="function"&&(P.globals.monaco=(0,g.createMonacoBaseAPI)())}),function(){var I,t;const E=self.MonacoEnvironment,P=E&&E.baseUrl?E.baseUrl:"../../../",A=typeof((I=self.trustedTypes)===null||I===void 0?void 0:I.createPolicy)=="function"?(t=self.trustedTypes)===null||t===void 0?void 0:t.createPolicy("amdLoader",{createScriptURL:f=>f,createScript:(f,...S)=>{const c=S.slice(0,-1).join(","),g=S.pop().toString();return`(function anonymous(${c}) {
${g}
})`}}):void 0;function l(){return new Promise((f,S)=>{if(typeof self.define=="function"&&self.define.amd)return f();const c=P+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)){fetch(c).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${c}`,(A?self.eval(A.createScript("",m)):new Function(m)).call(self),f()}).then(void 0,S);return}A?importScripts(A.createScriptURL(c)):importScripts(c),f()})}const h=function(f){l().then(()=>{require.config({baseUrl:P,catchError:!0,trustedTypesPolicy:A}),require([f],function(S){setTimeout(function(){let c=S.create((g,m)=>{self.postMessage(g,m)},null);for(self.onmessage=g=>c.onmessage(g.data);o.length>0;)self.onmessage(o.shift())},0)})})};let a=!0,o=[];self.onmessage=f=>{if(!a){o.push(f);return}a=!1,h(f.data)}}()}).call(this);

//# sourceMappingURL=./thirds/monaco-editor/min-maps/vs/base/worker/workerMain.js.map